
#include "entry.h"

extern int noOfItem;
extern transPtr *data;

extern int expectedK;

// 1: insert
// 0: not insert
int prob2Binary(double prob)
{
	int no;
	no = rand()%1000;

	if (prob*1000 >= no)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

void t_printEntry(tr_entryPtr T, int noOfT)
{
	int i;

	for (i = 0; i < noOfT; i++)
	{
		printf("%d. ", i);
		printf("(itemNo, freq, delta, level) = (%d, %d, %d, %d)\n", T[i].itemNo, T[i].freq, T[i].delta, T[i].level);
	}
}

// insert before index
void t_insertEntry(tr_entryPtr *inT, int *noOfT, int index, int itemNo, int freq, int delta, int level)
{
	tr_entryPtr t;
	tr_entryPtr newT;

	int no;
	

	t = (*inT);

	no = (*noOfT);
	newT = (tr_entryPtr) malloc(sizeof(tr_entry)*(no+1));
	
	if (index > 0)
	{
		memcpy(newT, t, sizeof(tr_entry)*index);
	}
	if (no-index > 0)
	{
		memcpy(&(newT[index+1]), &(t[index]), sizeof(tr_entry)*(no-index));
	}

	newT[index].itemNo = itemNo;
	newT[index].freq = freq;
	newT[index].delta = delta;
	newT[index].level = level;

	no++;
	(*noOfT) = no;

	if (no > 1)
	{
		free(t);
	}
	(*inT) = newT;
}

void t_deleteEntry(tr_entryPtr *inT, int *noOfT, int index)
{
	tr_entryPtr t;
	tr_entryPtr newT;

	int no;

	t = (*inT);

	no = (*noOfT);
	newT = (tr_entryPtr) malloc(sizeof(tr_entry)*(no-1));

	if (index > 0)
	{
		memcpy(newT, t, sizeof(tr_entry)*index);
	}
	if (no-index > 0)
	{
		memcpy(&(newT[index]), &(t[index+1]), sizeof(tr_entry)*(no-index-1));
	}

	no--;
	(*noOfT) = no;
	free(t);
	(*inT) = newT;
}

// the size of the common prefix
int t_checkCommonPrefix(int *tItemset, int sizeOfTItemset, int *x, int sizeOfX)
{
	int minSize;
	int i;
	int counter;

	if (sizeOfTItemset < sizeOfX)
	{
		minSize = sizeOfTItemset;
	}
	else
	{
		minSize = sizeOfX;
	}

	counter = 0;
	for (i = 0; i < minSize; i++)
	{
		if (tItemset[i] == x[i])
		{
			counter++;
		}
		else
		{
			break;
		}
	}
	return counter;
	
}

void t_insertItemset(tr_entryPtr *inT, int *noOfT, int *index, int itemNo, int freq, int delta, int level, int *prevItemset, int sizeOfPrevItemset, int *X, int sizeOfX)
{
	int sizePrefix;
	int i;

	sizePrefix = t_checkCommonPrefix(prevItemset, sizeOfPrevItemset, X, sizeOfX);

	for (i = sizePrefix; i < sizeOfX; i++)
	{
		t_insertEntry(inT, noOfT, (*index), X[i], freq, delta, i);
		(*index)++;
	}

	t_insertEntry(inT, noOfT, (*index), itemNo, freq, delta, level);
	(*index)++;
}

// 0 : equal
// 1 : itemset1 > itemset2
// -1: itemset1 < itemset2
int wordCompare(int *itemset1, int sizeOfItemset1, int *itemset2, int sizeOfItemset2)
{
	int i;

	int minSize;

	if (sizeOfItemset1 > sizeOfItemset2)
	{
		minSize = sizeOfItemset2;
	}
	else
	{
		minSize = sizeOfItemset1;
	}

	for (i = 0; i < minSize; i++)
	{
		if (itemset1[i] > itemset2[i])
		{
			return 1;
		}
		else if (itemset1[i] < itemset2[i])
		{
			return -1;
		}
		else
		{
		}
	}

	if (sizeOfItemset1 == sizeOfItemset2)
	{
		return 0;
	}
	else
	{
		if (sizeOfItemset1 > sizeOfItemset2)
		{
			return 1;
		}
		else
		{
			return -1;
		}
	}
	
}

// 0 : no more itemset
// 1 : still have itemset
int nextHeapItemset(heapPtr aHeap, int *heapItemset, int *sizeOfHeapItemset, int *newHeapFreq)
{
	int itemNo;

	// remove min
	itemNo = heap_removeMin(aHeap);

	if (itemNo == -1)
	{
		return 0;
	}

	// create the itemset for H
	memcpy(heapItemset, aHeap->condItemset, sizeof(int)*aHeap->noOfCondItemset);
	heapItemset[aHeap->noOfCondItemset] = itemNo;

	(*sizeOfHeapItemset) = aHeap->noOfCondItemset+1;

	(*newHeapFreq) = aHeap->hEntry[itemNo].noOfTid;

	return 1;
}

int nextTItemset(tr_entryPtr *inT, int *noOfT, int *index, int *prevItemset, int *sizeOfPrevItemset, int *currItemset, int *sizeOfCurrItemset)
{
	tr_entryPtr T;

	int tempSizeIndex;
	int tempItemNo;

	if ((*index)+1 >= (*noOfT))
	{
		return 0;
	}

	// prev. itemset
	memcpy(prevItemset, currItemset, sizeof(int)*(*sizeOfCurrItemset));
	(*sizeOfPrevItemset) = (*sizeOfCurrItemset);

	// not the end of the list of T
	T = (*inT);
	(*index) = (*index) + 1;
	tempSizeIndex = T[(*index)].level;
	tempItemNo = T[(*index)].itemNo;
	currItemset[tempSizeIndex] = tempItemNo;
	(*sizeOfCurrItemset) = tempSizeIndex+1;

	return 1;
}



// main step for combining the heap and entries
void entry_combine(int *prevItemset, int *sizeOfPrevItemset, int *currItemset, int *sizeOfCurrItemset, int *heapItemset, int *sizeOfHeapItemset, int heapFreq, tr_entryPtr *inT, int *noOfT, int *i, tr_entryPtr *inNewT, int *noOfNewT, int *newI, heapPtr *inH, int level, int b_current, int belta, int slideNo, int noOfBatchSlide)
{
	int *itemset1;
	int *itemset2;

	int sizeOfItemset1;
	int sizeOfItemset2;

	//int tempSizeIndex, tempItemNo;

	int y;

	int ansCompare;
	int ansNext;

	int newHeapFreq;

	int *X; 
	int sizeOfX;

	int tempLevel;

	tr_entryPtr T;

	itemset1 = currItemset;
	sizeOfItemset1 = (*sizeOfCurrItemset);

	itemset2 = heapItemset;
	sizeOfItemset2 = (*sizeOfHeapItemset);

//{
//int j;
//printf("~~~~itemset1: ");
//for (j = 0; j < sizeOfItemset1; j++)
//{
//printf("%d ", itemset1[j]);
//}
//printf("\t\t");

//if ((sizeOfItemset1 >= 1) && (itemset1[0] == 4))
//{
//printf("");
//}

//printf("itemset2: ");
//for (j = 0; j < sizeOfItemset2; j++)
//{
//printf("%d ", itemset2[j]);
//}
//printf("\n");
//}
	if (sizeOfItemset1 == 0)
	{
		// special case for the first elt
		ansCompare = 1;
	}
	else
	{
		ansCompare = wordCompare(itemset1, sizeOfItemset1, itemset2, sizeOfItemset2);
	}
	if (ansCompare == 0)	
	{
		// equal
		T = (*inT);
		T[(*i)].freq += heapFreq;

		//if (T[(*i)].freq + T[(*i)].delta <= b_current)
		if (T[(*i)].freq + T[(*i)].delta - (b_current - noOfBatchSlide*belta) <= noOfBatchSlide*belta)
		{
			// delete the entry
			t_deleteEntry(inT, noOfT, (*i));
			T = (*inT);

			// for T
			// need to minus the i due to deletion
			(*i)--;
		}
		else
		{
		}

		// for T
		if ((*i)+1 >= (*noOfT))
		{
			return;
		}

		// create the itemset for T
		ansNext = nextTItemset(inT, noOfT, i, prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset);
		// the following is redundant
		if (ansNext == 0)
		{
			return;
		}	

		// new
		// find y
		y = itemset2[sizeOfItemset2-1];

		X = inH[level]->condItemset;
		sizeOfX = inH[level]->noOfCondItemset;
		tempLevel = sizeOfX;

		// new
		t_insertItemset(inNewT, noOfNewT, newI, y, heapFreq, b_current-belta, tempLevel, prevItemset, (*sizeOfPrevItemset), X, sizeOfX);

		// find y
		y = itemset2[sizeOfItemset2-1];

		if (level+1 <= expectedK)
		{
			// build heap H[level+1]|Xy
			inH[level+1] = buildDeepHeap(inH[level], y, noOfItem, data);

			// create the itemset for H
			ansNext = nextHeapItemset(inH[level+1], heapItemset, sizeOfHeapItemset, &newHeapFreq);

			if (ansNext == 1)
			{
				// call combine
				entry_combine(prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset, heapItemset, sizeOfHeapItemset, newHeapFreq, inT, noOfT, i, inNewT, noOfNewT, newI, inH, level+1, b_current, belta, slideNo, noOfBatchSlide);
			}
			else
			{
				// do nothing
			}

			// freeing inH[level+1]
			freeHeap(inH[level+1]);
			free(inH[level+1]);
		}
		else
		{
			// do nothing
		}

		
			
		// create itemset for H
		ansNext = nextHeapItemset(inH[level], heapItemset, sizeOfHeapItemset, &newHeapFreq);

		if (ansNext == 1)
		{
			// call combine
			entry_combine(prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset, heapItemset, sizeOfHeapItemset, newHeapFreq, inT, noOfT, i, inNewT, noOfNewT, newI, inH, level, b_current, belta, slideNo, noOfBatchSlide);
		}
		
	}
	else if (ansCompare == 1)	
	{
		// larger
		// new itemset in the batch (which does not exist in T)
		if (heapFreq >= belta)
		{
			// find y
			y = itemset2[sizeOfItemset2-1];

			X = inH[level]->condItemset;
			sizeOfX = inH[level]->noOfCondItemset;
			tempLevel = sizeOfX;
			// insert a new entry
			t_insertItemset(inT, noOfT, i, y, heapFreq, b_current-belta, tempLevel, prevItemset, (*sizeOfPrevItemset), X, sizeOfX);

			// new
			t_insertItemset(inNewT, noOfNewT, newI, y, heapFreq, b_current-belta, tempLevel, prevItemset, (*sizeOfPrevItemset), X, sizeOfX);

			// set the prev. itemset
			memcpy(prevItemset, X, sizeOfX);
			prevItemset[sizeOfX] = y;
			(*sizeOfPrevItemset) = sizeOfX+1;

			if (level+1 <= expectedK)
			{
				// build heap H[level_1]|Xy
				inH[level+1] = buildDeepHeap(inH[level], y, noOfItem, data);
			
				// create the itemset for H
				ansNext = nextHeapItemset(inH[level+1], heapItemset, sizeOfHeapItemset, &newHeapFreq);

				if (ansNext == 1)
				{
					entry_combine(prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset, heapItemset, sizeOfHeapItemset, newHeapFreq, inT, noOfT, i, inNewT, noOfNewT, newI, inH, level+1, b_current, belta, slideNo, noOfBatchSlide);
				}
				else
				{
					// do nothing
				}

				// freeing inH[level+1]
				freeHeap(inH[level+1]);
				free(inH[level+1]);
			}
			else
			{
				// do nothing
			}
		}
		else
		{
			// do nothing
		}

		// create itemset for H
		ansNext = nextHeapItemset(inH[level], heapItemset, sizeOfHeapItemset, &newHeapFreq);

		if (ansNext == 1)
		{
			// call combine
			entry_combine(prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset, heapItemset, sizeOfHeapItemset, newHeapFreq, inT, noOfT, i, inNewT, noOfNewT, newI, inH, level, b_current, belta, slideNo, noOfBatchSlide);
		}
		
	}
	else	
	{
		// smaller
		// itemset in T does not exist in the batch

		if ((*i)+1 >= (*noOfT))
		{
			return;
		}

		// create the itemset for T
		ansNext = nextTItemset(inT, noOfT, i, prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset);
		// the following is redundant
		if (ansNext == 0)
		{
			return;
		}

		// call combine
		entry_combine(prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset, heapItemset, sizeOfHeapItemset, heapFreq, inT, noOfT, i, inNewT, noOfNewT, newI, inH, level, b_current, belta, slideNo, noOfBatchSlide);
	}
	
}

void entry_combineStart(tr_entryPtr *inT, int *noOfT, tr_entryPtr *inNewT, int *noOfNewT, heapPtr *inH, int b_current, int belta, int slideNo, int noOfBatchSlide, int noOfItem, int noOfTrans)
{
	int *prevItemset;
	int sizeOfPrevItemset;
	int *currItemset;
	int sizeOfCurrItemset;

	int *heapItemset;
	int sizeOfHeapItemset;
	int heapFreq;

	int i, newI;
	int level;
	int ansNext;

	tr_entryPtr T;

	

	level = 0;

	// building the heap
	printf("Building first heap...\n");
	inH[0] = buildFirstHeap(noOfItem, data, noOfTrans);
	
	printf("Printing the first heap....\n");
//	printHeap(inH[0]);

	prevItemset = (int *) malloc(sizeof(int)*noOfItem);
	currItemset = (int *) malloc(sizeof(int)*noOfItem);
	heapItemset = (int *) malloc(sizeof(int)*noOfItem);

	memset(prevItemset, 0, sizeof(int)*noOfItem);
	memset(currItemset, 0, sizeof(int)*noOfItem);
	memset(heapItemset, 0, sizeof(int)*noOfItem);

	// for T
	// PrevItemset
	sizeOfPrevItemset = 0;

	// currItemset
	if ((*noOfT) <= 0)
	{
		sizeOfCurrItemset = 0;

		//i = -1;
		i = 0;
	}
	else
	{
		T = (*inT);
		sizeOfCurrItemset = 1;
		currItemset[0] = T[0].itemNo;

		i = 0;
	}

	// new
	
	newI = 0;

	

	// For heap
	ansNext = nextHeapItemset(inH[0], heapItemset, &sizeOfHeapItemset, &heapFreq);
	if (ansNext == 1)
	{
		// has itemset
		printf("Processing...\n");
		entry_combine(prevItemset, &sizeOfPrevItemset, currItemset, &sizeOfCurrItemset, heapItemset, &sizeOfHeapItemset, heapFreq, inT, noOfT, &i, inNewT, noOfNewT, &newI, inH, level, b_current, belta, slideNo, noOfBatchSlide);
	}
	else
	{
		// no itemset
	}
	
	free(prevItemset);
	free(currItemset);
	free(heapItemset);

	// freeing h[0]
	freeHeap(inH[0]);
	free(inH[0]);
}




// main step for combining the heap and entries
void entry_removeCount(int *prevItemset, int *sizeOfPrevItemset, int *currItemset, int *sizeOfCurrItemset, int *oldItemset, int *sizeOfOldItemset, tr_entryPtr *inT, int *noOfT, int *i, tr_entryPtr *inOldT, int *noOfOldT, int *oldI, int level, int b_current, int belta, int slideNo, int noOfBatchSlide)
{
	int *itemset1;
	int *itemset2;

	int sizeOfItemset1;
	int sizeOfItemset2;

	//int tempSizeIndex, tempItemNo;

	//int y;

	int ansCompare;
	int ansNext;

	int oldFreq;

	//int newHeapFreq;

	//int *X; 
	//int sizeOfX;

	int tempLevel;

	tr_entryPtr T;

	itemset1 = currItemset;
	sizeOfItemset1 = (*sizeOfCurrItemset);

	itemset2 = oldItemset;
	sizeOfItemset2 = (*sizeOfOldItemset);

//{
//int j;
//printf("~~~~itemset1: ");
//for (j = 0; j < sizeOfItemset1; j++)
//{
//printf("%d ", itemset1[j]);
//}
//printf("\t\t");

//if ((sizeOfItemset1 >= 1) && (itemset1[0] == 4))
//{
//printf("");
//}

//printf("itemset2: ");
//for (j = 0; j < sizeOfItemset2; j++)
//{
//printf("%d ", itemset2[j]);
//}
//printf("\n");
//}
	if (sizeOfItemset1 == 0)
	{
		// special case for the first elt
		ansCompare = 1;
	}
	else
	{
		ansCompare = wordCompare(itemset1, sizeOfItemset1, itemset2, sizeOfItemset2);
	}
	if (ansCompare == 0)	
	{
		// equal
		oldFreq = (*inOldT)[(*oldI)].freq;

		T = (*inT);
		T[(*i)].freq -= oldFreq;

		//T[(*i)].delta += belta;
		T[(*i)].delta += belta;

		if (T[(*i)].freq <= 0)
		{
			// delete the entry
			t_deleteEntry(inT, noOfT, (*i));
			T = (*inT);

			// for T
			// need to minus the i due to deletion
			(*i)--;
		}

		// for T
		if ((*i)+1 >= (*noOfT))
		{
			return;
		}

		// create the itemset for T
		ansNext = nextTItemset(inT, noOfT, i, prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset);
		// the following is redundant
		if (ansNext == 0)
		{
			return;
		}	

		// for T (old)
		if ((*oldI)+1 >= (*noOfOldT))
		{
			return;
		}

		// create the itemset for T
		ansNext = nextTItemset(inOldT, noOfOldT, oldI, prevItemset, sizeOfPrevItemset, oldItemset, sizeOfOldItemset);
		// the following is redundant
		if (ansNext == 0)
		{
			return;
		}	

		// call removeCount
		entry_removeCount(prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset, oldItemset, sizeOfOldItemset, inT, noOfT, i, inOldT, noOfOldT, oldI, level, b_current, belta, slideNo, noOfBatchSlide);
		
	}
	else if (ansCompare == 1)	
	{

		// for T (old)
		if ((*oldI)+1 >= (*noOfOldT))
		{
			return;
		}

		// create the itemset for T
		ansNext = nextTItemset(inOldT, noOfOldT, oldI, prevItemset, sizeOfPrevItemset, oldItemset, sizeOfOldItemset);
		// the following is redundant
		if (ansNext == 0)
		{
			return;
		}	
		
		// call removeCount
		entry_removeCount(prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset, oldItemset, sizeOfOldItemset, inT, noOfT, i, inOldT, noOfOldT, oldI, level, b_current, belta, slideNo, noOfBatchSlide);
		
	}
	else	
	{
		// smaller
		// itemset in T does not exist in the batch

		if ((*i)+1 >= (*noOfT))
		{
			return;
		}

		// create the itemset for T
		ansNext = nextTItemset(inT, noOfT, i, prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset);
		// the following is redundant
		if (ansNext == 0)
		{
			return;
		}

		// call removeCount
		entry_removeCount(prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset, oldItemset, sizeOfOldItemset, inT, noOfT, i, inOldT, noOfOldT, oldI, level, b_current, belta, slideNo, noOfBatchSlide);
	}
	
}

void entry_removeBatchCount(tr_entryPtr *inT, int *noOfT, tr_entryPtr inOldT, int noOfOldT, int b_current, int belta, int slideNo, int noOfBatchSlide, int noOfItem, int noOfTrans)
{
	int *prevItemset;
	int sizeOfPrevItemset;
	int *currItemset;
	int sizeOfCurrItemset;

	int *oldItemset;
	int sizeOfOldItemset;
	//int oldFreq;

	int i, oldI;
	int level;
	int ansNext;

	tr_entryPtr T, oldT;

	

	level = 0;

	// building the heap
	//printf("Building first heap...\n");
	//inH[0] = buildFirstHeap(noOfItem, data, noOfTrans);
	
	//printf("Printing the first heap....\n");
//	printHeap(inH[0]);

	prevItemset = (int *) malloc(sizeof(int)*noOfItem);
	currItemset = (int *) malloc(sizeof(int)*noOfItem);
	oldItemset = (int *) malloc(sizeof(int)*noOfItem);

	memset(prevItemset, 0, sizeof(int)*noOfItem);
	memset(currItemset, 0, sizeof(int)*noOfItem);
	memset(oldItemset, 0, sizeof(int)*noOfItem);

	// for T
	// PrevItemset
	sizeOfPrevItemset = 0;

	// currItemset
	if ((*noOfT) <= 0)
	{
		sizeOfCurrItemset = 0;

		//i = -1;
		i = 0;
	}
	else
	{
		T = (*inT);
		sizeOfCurrItemset = 1;
		currItemset[0] = T[0].itemNo;

		i = 0;
	}

	// newe
	
	//newI = 0;

	// old
	if (noOfOldT <= 0)
	{
		sizeOfOldItemset = 0;

		oldI = 0;
	}
	else
	{

		oldT = inOldT;
		sizeOfOldItemset = 1;
		oldItemset[0] = oldT[0].itemNo;


		//oldFreq = oldT[0].freq;

		oldI = 0;
	}

	

	printf("Processing...\n");
	//entry_combine(prevItemset, &sizeOfPrevItemset, currItemset, &sizeOfCurrItemset, oldItemset, &sizeOfOldItemset, oldFreq, inT, noOfT, &i, inOldT, noOfOldT, &newI, inH, level, b_current, belta, slideNo, noOfBatchSlide);

	entry_removeCount(prevItemset, &sizeOfPrevItemset, currItemset, &sizeOfCurrItemset, oldItemset, &sizeOfOldItemset, inT, noOfT, &i, &inOldT, &noOfOldT, &oldI, level, b_current, belta, slideNo, noOfBatchSlide);
	
	free(prevItemset);
	free(currItemset);
	free(oldItemset);

	// freeing h[0]
	//freeHeap(inH[0]);
	//free(inH[0]);	
}






/*
// main step for combining the heap and entries
void sliding_mergeTwoResult(int *prevItemset, int *sizeOfPrevItemset, int *currItemset, int *sizeOfCurrItemset, int *newItemset, int *sizeOfNewItemset, int newFreq, tr_entryPtr *inT, int *noOfT, int *i, heapPtr *inH, int level, int b_current, int belta)
{
	int *itemset1;
	int *itemset2;

	int sizeOfItemset1;
	int sizeOfItemset2;

	//int tempSizeIndex, tempItemNo;

	int y;

	int ansCompare;
	int ansNext;

	int newHeapFreq;

	int *X; 
	int sizeOfX;

	int tempLevel;

	tr_entryPtr T;

	itemset1 = currItemset;
	sizeOfItemset1 = (*sizeOfCurrItemset);

	itemset2 = heapItemset;
	sizeOfItemset2 = (*sizeOfHeapItemset);

//{
//int j;
//printf("~~~~itemset1: ");
//for (j = 0; j < sizeOfItemset1; j++)
//{
//printf("%d ", itemset1[j]);
//}
//printf("\t\t");

//if ((sizeOfItemset1 >= 1) && (itemset1[0] == 4))
//{
//printf("");
//}

//printf("itemset2: ");
//for (j = 0; j < sizeOfItemset2; j++)
//{
//printf("%d ", itemset2[j]);
//}
//printf("\n");
//}
	if (sizeOfItemset1 == 0)
	{
		// special case for the first elt
		ansCompare = 1;
	}
	else
	{
		ansCompare = wordCompare(itemset1, sizeOfItemset1, itemset2, sizeOfItemset2);
	}
	if (ansCompare == 0)	
	{
		// equal
		T = (*inT);
		T[(*i)].freq += heapFreq;

		// for T
		if ((*i)+1 >= (*noOfT))
		{
			return;
		}

		// create the itemset for T
		ansNext = nextTItemset(inT, noOfT, i, prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset);
		// the following is redundant
		if (ansNext == 0)
		{
			return;
		}	

		// for T
		if ((*newI)+1 >= (*noOfNewT))
		{
			return;
		}

		// create the itemset for T
		ansNext = nextTItemset(inNewT, noOfNewT, newI, prevNewItemset, sizeOfNewPrevItemset, currNewItemset, sizeOfCurrNewItemset);
		// the following is redundant
		if (ansNext == 0)
		{
			return;
		}	

	}
	else if (ansCompare == 1)	
	{
		// larger
		// new itemset in the batch (which does not exist in T)
		//if (heapFreq >= belta)
		//{

		// find y
		y = itemset2[sizeOfItemset2-1];

		X = inH[level]->condItemset;
		sizeOfX = inH[level]->noOfCondItemset;
		tempLevel = sizeOfX;
		// insert a new entry
		t_insertItemset(inT, noOfT, i, y, heapFreq, b_current-belta, tempLevel, prevItemset, (*sizeOfPrevItemset), X, sizeOfX);

		// set the prev. itemset
		memcpy(prevItemset, X, sizeOfX);
		prevItemset[sizeOfX] = y;
		(*sizeOfPrevItemset) = sizeOfX+1;

		// for T
		if ((*newI)+1 >= (*noOfNewT))
		{
			return;
		}

		// create the itemset for T
		ansNext = nextTItemset(inNewT, noOfNewT, newI, prevNewItemset, sizeOfNewPrevItemset, currNewItemset, sizeOfCurrNewItemset);
		// the following is redundant
		if (ansNext == 0)
		{
			return;
		}	
	
	}
	else	
	{
		// smaller
		// itemset in T does not exist in the batch

		if ((*i)+1 >= (*noOfT))
		{
			return;
		}

		// create the itemset for T
		ansNext = nextTItemset(inT, noOfT, i, prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset);
		// the following is redundant
		if (ansNext == 0)
		{
			return;
		}

		// call combine
		sliding_mergetTwoResult(prevItemset, sizeOfPrevItemset, currItemset, sizeOfCurrItemset, heapItemset, sizeOfHeapItemset, heapFreq, inT, noOfT, i, inH, level, b_current, belta);
	}
	
}

void sliding_mergeTwoResultStart(tr_entryPtr *outT, int *noOfOutT, tr_entryPtr batchT, int noOfBatchT)
{


	int *prevItemset;
	int sizeOfPrevItemset;
	int *currItemset;
	int sizeOfCurrItemset;

	int *newItemset;
	int sizeOfNewItemset;
	int newItemsetFreq;

	int i, newI;
	int level;
	//int ansNext;

	tr_entryPtr T;

	

	level = 0;

	// building the heap
//	printf("Building first heap...\n");
//	inH[0] = buildFirstHeap(noOfItem, data, noOfTrans);
	
	printf("Printing the first heap....\n");
//	printHeap(inH[0]);

	prevItemset = (int *) malloc(sizeof(int)*noOfItem);
	currItemset = (int *) malloc(sizeof(int)*noOfItem);
	newItemset = (int *) malloc(sizeof(int)*noOfItem);

	memset(prevItemset, 0, sizeof(int)*noOfItem);
	memset(currItemset, 0, sizeof(int)*noOfItem);
	memset(newItemset, 0, sizeof(int)*noOfItem);

	//

	if ((*noOfOutT) == 0)
	{
		sizeOfCurrItemset = 0;
		i = 0;
	}
	else
	{
		T = (*outT);
		sizeOfCurrItemset = 1;
		currItemset[0] = T[0].itemNo;
		i = 0;
	}

	if (noOfBatchT > 0)
	{
		sizeOfNewItemset = 1;
		newItemset[0] = batchT[0].itemNo;
		newI = 0;
		newItemsetFreq = batchT[0].freq;

		//sliding_mergetTwoResult();
	}
	else
	{
		// do nothing
	}

	free(prevItemset);
	free(currItemset);
	free(newItemset);

	// freeing h[0]
	//freeHeap(inH[0]);
	//free(inH[0]);
}



void sliding_mergeResult(tr_entryPtr *outT, int *noOfOutT, tr_entryPtr *batchT, int *noOfBatchT, int noOfBatchSlide)
{
	int i;

	for (i = 0; i < noOfBatchSlide; i++)
	{
		sliding_mergeTwoResultStart(outT, noOfOutT, batchT[i], noOfBatchT[i]);
	}
}


*/



int main4()
{
	int *itemset1;
	int *itemset2;

	int sizeOfItemset1;
	int sizeOfItemset2;

	int ans;
	int i;

	sizeOfItemset1 = 1;
	sizeOfItemset2 = 3;

	itemset1 = (int *) malloc(sizeof(int)*sizeOfItemset1);
	itemset2 = (int *) malloc(sizeof(int)*sizeOfItemset2);

	itemset1[0] = 0;
	//itemset1[1] = 1;
	//itemset1[2] = 3;

	itemset2[0] = 0;
	itemset2[1] = 1;
	itemset2[2] = 2;

	printf("Itemset1: ");
	for (i = 0; i < sizeOfItemset1; i++)
	{
		printf("%d ", itemset1[i]);
	}
	printf("\n");

	printf("Itemset2: ");
	for (i = 0; i < sizeOfItemset2; i++)
	{
		printf("%d ", itemset2[i]);
	}
	printf("\n");

	//ans = int t_checkCommonPrefix(int *tItemset, int sizeOfTItemset, int *x, int sizeOfX);
	ans = t_checkCommonPrefix(itemset1, sizeOfItemset1, itemset2, sizeOfItemset2);


	//ans = wordCompare(itemset1, sizeOfItemset1, itemset2, sizeOfItemset2);

	printf("ans:%d\n", ans);

	free(itemset1);
	free(itemset2);

	return 0;
}

int main5()
{
	tr_entryPtr T;
	int noOfT;
	int counter;

	char *filename = "data.txt";
	int noOfTrans = 8;

	int maxTransSize = 20;
	

	heapPtr *h;

	int b_current;
	int belta;

	//T = (tr_entryPtr) malloc(sizeof(entry)*);

	noOfItem = 7;

	
	b_current = 4;
	belta = 4;

	// T initialization
	noOfT = 0;
	

	//void t_insertEntry(tr_entryPtr *inT, int *noOfT, int index, int itemNo, int freq, int delta, int level)
	counter = 0;
	t_insertEntry(&T, &noOfT, counter, 0, 6, 2, 0);
	counter++;
	t_insertEntry(&T, &noOfT, counter, 1, 5, 2, 1);
	counter++;
	t_insertEntry(&T, &noOfT, counter, 2, 2, 2, 2);
	counter++;
	t_insertEntry(&T, &noOfT, counter, 2, 3, 2, 1);
	counter++;

	t_insertEntry(&T, &noOfT, counter, 1, 7, 3, 0);
	counter++;

	t_insertEntry(&T, &noOfT, counter, 2, 4, 1, 0);
	counter++;
	t_insertEntry(&T, &noOfT, counter, 4, 2, 1, 1);
	counter++;

	t_insertEntry(&T, &noOfT, counter, 4, 5, 5, 0);
	counter++;

	// printing T
	printf("Printing T...\n");
//	t_printEntry(T, noOfT);

	// read trans
	printf("Reading the data...\n");
	data = readData(filename, noOfTrans);

	h = (heapPtr *) malloc(sizeof(heap)*maxTransSize);

	// combine
	//entry_combineStart(&T, &noOfT, h, b_current, belta, noOfItem, noOfTrans);
	
	// printing T
	printf("Printing T...\n");
//	t_printEntry(T, noOfT);

	free(h);

	return 0;
}
