
#ifndef HEAP_H
#define HEAP_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "trans.h"

struct heapEntry_s
{
	int itemNo;

	int *tid;
	int *index;
	int noOfTid;
};

typedef struct heapEntry_s heapEntry;
typedef heapEntry *heapEntryPtr;




struct heap_s
{
        int  noOfElt;           /* No of elements in the heap right now */
        int  capacity;    /* Max no. of elements in the heap         */
        int *elt;  /* An array storing the elements             */

		heapEntryPtr hEntry;

		int *condItemset;
		int noOfCondItemset;
};

typedef struct heap_s heap;
typedef heap *heapPtr;

int heap_removeMin(heapPtr aHeap);
heapPtr buildDeepHeap(heapPtr aHeap, int itemNo, int capacity, transPtr *data);
heapPtr buildFirstHeap(int capacity, transPtr *data, int noOfTrans);
void printHeap(heapPtr aHeap);
void freeHeap(heapPtr aHeap);

#endif
