
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef _WIN32
#include <sys/resource.h>
#include <sys/times.h>
#include <unistd.h>
#endif
#include "entry.h"
#include "heap.h"
#include "trans.h"
#include "fptN20.h"

int noOfItem;
transPtr *data;

int topK;
int expectedK;

char *configFile;

int maxTransSize;
int noOfTransRead;
int noOfTrans;

double epsilon;
double suppThreshold;

double sigma;
int R, D;

int noOfBatch;


extern int N;
extern int expectedK;
extern int realK;
extern int threshold;
extern int oldThreshold;
extern int numItem;
extern int numTrans;
extern float decreaseRate;
extern char dataFile[300];
extern char treeFile[300];
extern char outFile[300];


extern int noOfSkip;

int ceiling(double no)
{
	double temp;

	int returnValue;

	temp = (no - (int) no);

	if (temp == 0.0)
	{
		returnValue = (int) no;
	}
	else
	{
		returnValue = (int) (no+1);
	}
	return returnValue;
}

int findSmallest(entryPtr e, int noOfE, int topK)
{
	int returnValue;

	int i, j;
	//int smallest, secondSmallest;
	//int noOfLarger;
	int temp;

	int *list;

	if (noOfE > 0)
	{
		//smallest = e[0].count;
		//secondSmallest = smallest;
	}
	else
	{
		return 0;
	}

	list = (int *) malloc(sizeof(int)*noOfE);
	for (i = 0; i < noOfE; i++)
	{
		list[i] = e[i].count;
	}

	for (i = 0; i < noOfE-1; i++)
	{
		for (j = 0; j < noOfE-i-1; j++)
		{
			if (list[j] < list[j+1])
			{
				// swap
				temp = list[j];
				list[j] = list[j+1];
				list[j+1] = temp;
			}
		}
	}

	if (noOfE <= topK)
	{
		returnValue = list[noOfE-1];
	}
	else
	{
		returnValue = list[topK-1];
	}

	free(list);

	return returnValue;

	
}

entryPtr *findResultFromT_Ver1(tr_entryPtr T, int noOfT, int topK, int expectedK, int *noOfResult)
{
	entryPtr *returnValue;

	int i;

	int *tempItemset;

	int level;
	int itemNo;
	int freq;
	int delta;

	int size;

	int *Klargest;


	returnValue = (entryPtr *) malloc(sizeof(entryPtr)*expectedK);

	tempItemset = (int *) malloc(sizeof(int)*noOfItem);
	memset(noOfResult, 0, sizeof(int)*expectedK);

	Klargest = (int *) malloc(sizeof(int)*expectedK);
	memset(Klargest, 0, sizeof(int)*expectedK);

	for (i = 0; i < noOfT; i++)
	{
		itemNo = T[i].itemNo;
		freq = T[i].freq;
		delta = T[i].delta;
		level = T[i].level;

		tempItemset[level] = itemNo;

		size = level+1;
		if (size <= expectedK)
		{

//{
//int j;
//printf("-------------  Itemset: ");
//for (j = 0; j < size; j++)
//{
//printf("%d ", tempItemset[j]);
//}
//printf("\t freq:%d\n", freq);
//}

			// check freq
			// if the freq > the current best
			if ((noOfResult[level] < topK) || (freq >= Klargest[level]))
			{
				// add this itemset
				//
				int preKLargest;


				preKLargest = Klargest[level];

				// add itemset
				addEntry(&(returnValue[level]), noOfResult[level], tempItemset, size, freq);
				noOfResult[level]++;

				// 
				//Klargest[level] = freq;
				Klargest[level] = findSmallest(returnValue[level], noOfResult[level], topK);

				// if there is fewer than K itemsets or the freq = K-th largest
				if ((noOfResult[level] <= topK) || (freq == preKLargest))
				{
					// do nothing
				}
				else
				{
					// else
					// remove some 
					//void removeEntry(entryPtr *bucket, int *noOfEntry, int freq)

					//if (preKLargest == Klargest[level])
					//{
					//}
					//else
					if (preKLargest < Klargest[level])
					{
						removeEntry(&(returnValue[level]), &(noOfResult[level]), preKLargest);
						Klargest[level] = findSmallest(returnValue[level], noOfResult[level], topK);
					}
				}


			}
		}

		
	}

	free(tempItemset);
	free(Klargest);

	return returnValue;
}


entryPtr *findResultFromT_Ver2(tr_entryPtr T, int noOfT, int topK, int expectedK, int *noOfResult)
{
	entryPtr *returnValue;
	entryPtr *tempValue;

	int i, j;

	int *tempItemset;

	int level;
	int itemNo;
	int freq;
	int delta;

	int size;

	int *Klargest;

	int *noOfTempResult;


	tempValue = (entryPtr *) malloc(sizeof(entryPtr)*expectedK);
	returnValue = (entryPtr *) malloc(sizeof(entryPtr)*expectedK);

	tempItemset = (int *) malloc(sizeof(int)*noOfItem);

	noOfTempResult = (int *) malloc(sizeof(int)*expectedK);
	memset(noOfTempResult, 0, sizeof(int)*expectedK);

	memset(noOfResult, 0, sizeof(int)*expectedK);

	Klargest = (int *) malloc(sizeof(int)*expectedK);
	memset(Klargest, 0, sizeof(int)*expectedK);

	// find the f_K
	for (i = 0; i < noOfT; i++)
	{
		itemNo = T[i].itemNo;
		freq = T[i].freq;
		delta = T[i].delta;
		level = T[i].level;

		tempItemset[level] = itemNo;

		size = level+1;
		if (size <= expectedK)
		{

//{
//int j;
//printf("-------------  Itemset: ");
//for (j = 0; j < size; j++)
//{
//printf("%d ", tempItemset[j]);
//}
//printf("\t freq:%d\n", freq);
//}

			// check freq
			// if the freq > the current best
			if ((noOfTempResult[level] < topK) || (freq >= Klargest[level]))
			{
				// add this itemset
				//
				int preKLargest;

				preKLargest = Klargest[level];

				

				// add itemset
				addEntry(&(tempValue[level]), noOfTempResult[level], tempItemset, size, freq);
				noOfTempResult[level]++;

				// 
				//Klargest[level] = freq;
				Klargest[level] = findSmallest(tempValue[level], noOfTempResult[level], topK);

				// if there is fewer than K itemsets or the freq = K-th largest
				if ((noOfTempResult[level] <= topK) || (freq == preKLargest))
				{
					// do nothing
				}
				else
				{
					// else
					// remove some 
					//void removeEntry(entryPtr *bucket, int *noOfEntry, int freq)

					//if (preKLargest == Klargest[level])
					//{
					//}
					//else
					if (preKLargest < Klargest[level])
					{
						removeEntry(&(tempValue[level]), &(noOfTempResult[level]), preKLargest);
						Klargest[level] = findSmallest(tempValue[level], noOfTempResult[level], topK);
					}
				}
			}
		}

		
	}

	// insert the itemset with freq f+2e N >= f_K
	for (i = 0; i < noOfT; i++)
	{
		itemNo = T[i].itemNo;
		freq = T[i].freq;
		delta = T[i].delta;
		level = T[i].level;

		tempItemset[level] = itemNo;

		size = level+1;
		if (size <= expectedK)
		{

//{
//int j;
//printf("-------------  Itemset: ");
//for (j = 0; j < size; j++)
//{
//printf("%d ", tempItemset[j]);
//}
//printf("\t freq:%d\n", freq);
//}
			//suppThreshold = 0.1*Klargest[level];
			suppThreshold = epsilon*noOfTransRead;

			// check freq
			// if freq + 2eN >= f_K
			//if (freq + 2*suppThreshold >= Klargest[level])
			if (freq + 2*epsilon >= Klargest[level])
			{
				// add itemset
				addEntry(&(returnValue[level]), noOfResult[level], tempItemset, size, freq);
				noOfResult[level]++;				
			}
		}

		
	}

	free(tempItemset);
	free(Klargest);

	for (i = 0; i < expectedK; i++)
	{
		for (j = 0; j < noOfTempResult[i]; j++)
		{
			free(tempValue[i][j].item);
		}
		free(tempValue[i]);
	}
	free(noOfTempResult);

	return returnValue;
	//return NULL;
}

void lossyMain(char *filename, int noOfBatches, int maxTransSize, double epsilon, int beta)
{
	//int beta;
	int bucketSize;

	
	//int noOfBatches;
	//int maxTransSize;

	int i, j, k;

	//int noOfTrans;
	int batchNoOfTrans;

	heapPtr *h;

	tr_entryPtr T;
	int noOfT;

	tr_entryPtr *batchT;
	int *noOfBatchT;

	int b_current;

	int noOfBatchSlide;
	int slideNo;


	//
	int *noOfBOMOResult;
	entryPtr *bomoResult;

	int *noOfFinal;
	entryPtr *finalResult;

	int *noOfFalsePos;
	int *noOfFalseNeg;

	FILE *debugFilePtr;

	int storage;

#ifndef _WIN32
 float  userTime, sysTime;
 struct rusage myTime1, myTime2;
 //struct rusage myTime3, myTime4;
 FILE *timeFilePtr;
 //FILE *timeFilePtr2;

	// 
	timeFilePtr = (FILE *) fopen("time.txt", "w");

#endif
	debugFilePtr = (FILE *) fopen("output.txt", "w");

	// to be changed
	noOfBatchSlide = noOfBatch;

	//
	//noOfItem = 7;
	//noOfTrans = 8;
	//maxTransSize = 12;

	//beta = 2;
	//bucketSize = 4;
	bucketSize = ceiling(1.0/epsilon);

	batchT = (tr_entryPtr *) malloc(sizeof(tr_entryPtr)*noOfBatchSlide);
	noOfBatchT = (int *) malloc(sizeof(int)*noOfBatchSlide);
	memset(noOfBatchT, 0, sizeof(int)*noOfBatchSlide);

	// initialization
	noOfT = 0;

	batchNoOfTrans = beta*bucketSize;

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime1);
#endif 

	//for every batch containing beta buckets
//noOfBatches = 1000;
	for (i = 0; i < noOfBatches; i++)
	{
		slideNo = i;

		if (slideNo >= noOfBatchSlide)
		{
			// 
			//void entry_removeBatchCount(tr_entryPtr *inT, int *noOfT, tr_entryPtr inNewT, int noOfNewT, int slideNo, int noOfBatchSlide, int noOfItem, int noOfTrans)
			entry_removeBatchCount(&T, &noOfT, batchT[0], noOfBatchT[0], b_current, beta, slideNo, noOfBatchSlide, noOfItem, noOfTrans);


			// free batchT and noOfBatch with index 0
			if (noOfBatchT[0] > 0)
			{
				free(batchT[0]);
			}

			for (j = 0; j < noOfBatchSlide-1; j++)
			{
				batchT[j] = batchT[j+1];
				noOfBatchT[j] = noOfBatchT[j+1];
			}

			slideNo = noOfBatchSlide-1;
			batchT[slideNo] = NULL;
			noOfBatchT[slideNo] = 0;
		}


		printf("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Batch %d ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n", i);
		fprintf(debugFilePtr, "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Batch %d ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n", i);

		// initialize
		b_current = (i+1)*beta;
		noOfSkip = i*batchNoOfTrans;

		printf("Reading the data...\n");
		data = readData(filename, batchNoOfTrans);

		h = (heapPtr *) malloc(sizeof(heap)*maxTransSize);

		// combine
		entry_combineStart(&T, &noOfT, &(batchT[slideNo]), &(noOfBatchT[slideNo]), h, b_current, beta, slideNo, noOfBatchSlide, noOfItem, batchNoOfTrans);
		//entry_combineStart(&(batchT[slideNo]), &(noOfBatchT[slideNo]), h, b_current, beta, noOfItem, batchNoOfTrans);
	
		// printing T
		printf("Printing T...\n");
		//t_printEntry(T, noOfT);

		// free data
		for (j = 0; j < batchNoOfTrans; j++)
		{
			free(data[j]->item);
			free(data[j]);
		}
		free(data);

		free(h);
	}

	// generate final results T

	//sliding_mergeResult(&T, &noOft, batchT, noOfBatchT, noOfBatchSlide);

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime2);	

 userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
 sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

 printf("User time : %f seconds\n",userTime);
 printf("System time : %f seconds\n\n",sysTime);

 	
	fprintf(timeFilePtr, "Lossy\n");
	fprintf(timeFilePtr, "-----------\n");
	fprintf(timeFilePtr, "User time : %f seconds\n",userTime);
    fprintf(timeFilePtr, "System time : %f seconds\n\n",sysTime);

#endif

	// find the result from T
	// result
	noOfFinal = (int *) malloc(sizeof(int)*expectedK);
	memset(noOfFinal, 0, sizeof(int)*expectedK);
	//entryPtr *findResultFromT(tr_entryPtr T, int noOfT, int topK, int expectedK, int *noOfResult)
	finalResult = findResultFromT_Ver1(T, noOfT, topK, expectedK, noOfFinal);
	//finalResult = findResultFromT_Ver2(T, noOfT, topK, expectedK, noOfFinal);

	printf("Lossy Result(Version 1)\n");
	printf("=======================\n");
	fprintf(debugFilePtr, "Lossy Result(Version 1)\n");
	fprintf(debugFilePtr, "=======================\n");
	for (i = 0; i < expectedK; i++)
	{
		printf("Size %d\n", i);
		printf("~~~~~~~\n");
		fprintf(debugFilePtr, "Size %d\n", i);
		fprintf(debugFilePtr, "~~~~~~~\n");
		for (k = 0; k < noOfFinal[i]; k++)
		{
			for (j = 0; j < i+1; j++)
			{
				printf("%d ", finalResult[i][k].item[j]);
				fprintf(debugFilePtr, "%d ", finalResult[i][k].item[j]);
			}	
			printf("\t%d\n", finalResult[i][k].count);
			fprintf(debugFilePtr, "\t%d\n", finalResult[i][k].count);
		}
	}
	

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime1);
#endif 



	printf("processing BOMO...\n");
	//fprintf(debugFilePtr, "processing BOMO...\n");
	noOfBOMOResult = (int *) malloc(sizeof(int)*expectedK);
	//bomoResult = processBOMO(configFile, 0, noOfTransRead, topK, expectedK, noOfBOMOResult);
	bomoResult = processBOMO(configFile, noOfTransRead - noOfBatch*R, noOfBatch*R, topK, expectedK, noOfBOMOResult);

	// sort the BOMO result
	printf("Sorting...\n");
	sortItemOrder(bomoResult, noOfBOMOResult);

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime2);	

 userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
 sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

 printf("User time : %f seconds\n",userTime);
 printf("System time : %f seconds\n\n",sysTime);

 	
	fprintf(timeFilePtr, "BOMO\n");
	fprintf(timeFilePtr, "-----------\n");
	fprintf(timeFilePtr, "User time : %f seconds\n",userTime);
    fprintf(timeFilePtr, "System time : %f seconds\n\n",sysTime);

	fclose(timeFilePtr);
#endif

	printf("BOMO Result\n");
	printf("===========\n");
	fprintf(debugFilePtr, "BOMO Result\n");
	fprintf(debugFilePtr, "===========\n");
	for (i = 0; i < expectedK; i++)
	{
		printf("Size %d\n", i);
		printf("~~~~~~~\n");
		fprintf(debugFilePtr, "Size %d\n", i);
		fprintf(debugFilePtr, "~~~~~~~\n");
		for (k = 0; k < noOfBOMOResult[i]; k++)
		{
			for (j = 0; j < i+1; j++)
			{
				printf("%d ", bomoResult[i][k].item[j]);
				fprintf(debugFilePtr, "%d ", bomoResult[i][k].item[j]);
			}	
			printf("\t%d\n", bomoResult[i][k].count);
			fprintf(debugFilePtr, "\t%d\n", bomoResult[i][k].count);
		}
	}

	// compare (false +ve/-ve) (for Version 1)
	noOfFalsePos = (int *) malloc(sizeof(int)*expectedK);
	noOfFalseNeg = (int *) malloc(sizeof(int)*expectedK);
	compareResult(finalResult, noOfFinal, bomoResult, noOfBOMOResult, noOfFalsePos, noOfFalseNeg);

/*

	// version 2
	printf("Version 2\n");
	printf("=========\n");
	fprintf(debugFilePtr, "Version 2\n");
	fprintf(debugFilePtr, "=========\n");
	finalResult = findResultFromT_Ver2(T, noOfT, topK, expectedK, noOfFinal);
*/
	printf("Lossy Result(Version 1)\n");
	printf("=======================\n");
	fprintf(debugFilePtr, "Lossy Result(Version 1)\n");
	fprintf(debugFilePtr, "=======================\n");
	for (i = 0; i < expectedK; i++)
	{
		printf("Size %d\n", i);
		printf("~~~~~~~\n");
		fprintf(debugFilePtr, "Size %d\n", i);
		fprintf(debugFilePtr, "~~~~~~~\n");
		for (k = 0; k < noOfFinal[i]; k++)
		{
			for (j = 0; j < i+1; j++)
			{
				printf("%d ", finalResult[i][k].item[j]);
				fprintf(debugFilePtr, "%d ", finalResult[i][k].item[j]);
			}	
			printf("\t%d\n", finalResult[i][k].count);
			fprintf(debugFilePtr, "\t%d\n", finalResult[i][k].count);
		}
	}

	// print result (For Version 1)
	printf("Final Result\n");
	printf("------------\n");
	fprintf(debugFilePtr, "Final Result\n");
	fprintf(debugFilePtr, "------------\n");

	storage = 0;
	for (i = 0; i < noOfBatchSlide; i++)
	{
		storage += noOfBatchT[i];
	}

	// memory usage (For Version 1)
	printf("K = %d\n", topK);
	printf("no. of entries stored(T): %d\n", noOfT);
	printf("no. of entries stored(batchT): %d\n", storage);
	fprintf(debugFilePtr, "K = %d\n", topK);
	fprintf(debugFilePtr, "no. of entries stored(T): %d\n", noOfT);
	fprintf(debugFilePtr, "no. of entries stored(batchT): %d\n", storage);

	// print the false +ve/-ve (For Version 1)
	for (i = 0; i < expectedK; i++)
	{
		//for (j = 0; j < noOfSlot; j++)
		//{
		//	stored[i] += noOfSetFEntry[i][j];
		//}

		printf("Size %d\n", i);
		printf("  No. of Stream Output    : %d\n", noOfFinal[i]);
		printf("  No. of BOMO Output      : %d\n", noOfBOMOResult[i]);
		printf("  No. of false positives  : %d\n", noOfFalsePos[i]);
		printf("  No. of false negatives  : %d\n", noOfFalseNeg[i]);
		fprintf(debugFilePtr, "Size %d\n", i);
		fprintf(debugFilePtr, "  No. of Stream Output    : %d\n", noOfFinal[i]);
		fprintf(debugFilePtr, "  No. of BOMO Output      : %d\n", noOfBOMOResult[i]);
		fprintf(debugFilePtr, "  No. of false positives  : %d\n", noOfFalsePos[i]);
		fprintf(debugFilePtr, "  No. of false negatives  : %d\n", noOfFalseNeg[i]);
	}
/*
	// for Version 2
	compareResult(finalResult, noOfFinal, bomoResult, noOfBOMOResult, noOfFalsePos, noOfFalseNeg);

	// print result
	printf("Final Result\n");
	printf("------------\n");
	fprintf(debugFilePtr, "Final Result\n");
	fprintf(debugFilePtr, "------------\n");

	// memory usage
	printf("K = %d\n", topK);
	printf("no. of entries stored(T): %d\n", noOfT);
	fprintf(debugFilePtr, "K = %d\n", topK);
	fprintf(debugFilePtr, "no. of entries stored(T): %d\n", noOfT);

	// print the false +ve/-ve
	for (i = 0; i < expectedK; i++)
	{
		//for (j = 0; j < noOfSlot; j++)
		//{
		//	stored[i] += noOfSetFEntry[i][j];
		//}

		printf("Size %d\n", i);
		printf("  No. of Stream Output    : %d\n", noOfFinal[i]);
		printf("  No. of BOMO Output      : %d\n", noOfBOMOResult[i]);
		printf("  No. of false positives  : %d\n", noOfFalsePos[i]);
		printf("  No. of false negatives  : %d\n", noOfFalseNeg[i]);
		fprintf(debugFilePtr, "Size %d\n", i);
		fprintf(debugFilePtr,"  No. of Stream Output    : %d\n", noOfFinal[i]);
		fprintf(debugFilePtr,"  No. of BOMO Output      : %d\n", noOfBOMOResult[i]);
		fprintf(debugFilePtr,"  No. of false positives  : %d\n", noOfFalsePos[i]);
		fprintf(debugFilePtr,"  No. of false negatives  : %d\n", noOfFalseNeg[i]);
	}

*/
	// freeing
	printf("Freeing..\n");
	if (noOfT > 0)
	{
		free(T);
	}
	
	for (i = 0; i < expectedK; i++)
	{
		for (j = 0; j < noOfBOMOResult[i]; j++)
		{
			free(bomoResult[i][j].item);
		}
		if (noOfBOMOResult[i] > 0)
		{
			free(bomoResult[i]);
		}

		for (j = 0; j < noOfFinal[i]; j++)
		{
			free(finalResult[i][j].item);
		}
		if (noOfFinal[i] > 0)
		{
			free(finalResult[i]);
		}
	}
	free(bomoResult);
	free(noOfBOMOResult);

	free(finalResult);
	free(noOfFinal);

	free(noOfFalsePos);
	free(noOfFalseNeg);
	
	
	 
}


void lossy_input(char *configFile)
{
 FILE *fp;
 float thresholdDecimal;
 float floatNo;



 if ((fp = fopen(configFile, "r")) == NULL) {
        printf("Can't open config. file, %s.\n", configFile);
        exit(1);
 }

 fscanf(fp, "%d %d %f %d %d %f", &N, &expectedK, &thresholdDecimal, &numItem, &numTrans, &decreaseRate);
 fscanf(fp, "%s %s %s", dataFile, treeFile, outFile);

 noOfItem = numItem;
 noOfTrans = numTrans;
 topK = N;

 fscanf(fp, "%d", &D);
 fscanf(fp, "%d", &maxTransSize);
 fscanf(fp, "%d", &noOfTransRead);
 fscanf(fp, "%f", &floatNo);
 fscanf(fp, "%d", &R);

 sigma = (double) floatNo;

 fscanf(fp, "%f", &floatNo);
 epsilon = (double) floatNo;

 fscanf(fp, "%d", &noOfBatch);


 fclose(fp);
/*
 printf("N = %d\n", N);
 printf("expectedK = %d\n", expectedK);
 printf("thresholdDecimal = %f (dummy)\n", thresholdDecimal);
 printf("numItem = %d\n", numItem);
 printf("numTrans = %d\n", numTrans);
 printf("decreaseRate = %f\n", decreaseRate);
 printf("dataFile = %s\n", dataFile);
 printf("treeFile = %s\n", treeFile);
 printf("outFile = %s\n\n", outFile);
*/
 threshold = (int) (thresholdDecimal * numTrans);
 //printf("threshold = %d (dummy)\n", threshold);

 //oldThreshold = numTrans;

 if (N > numItem) {
	printf("N > numItem\n");
	exit(1);
 }	

 if (noOfTransRead > noOfTrans)
 {
	 printf("no. of trans. read > no. of trans in the data set!\n");
	 exit(1);
 }

 
 return;
}

int main()
{
	//char *confFilename = "configSample.txt";
	//char *datafilename = "data2.txt";
	//double epsilon;
	int beta;
	int noOfBatches;

	int width;


	

	
	//
//	noOfItem = 7;
//	maxTransSize = 12;
//	noOfTrans = 16;//8;

	//
	configFile = (char *) malloc(sizeof(char)*300);
	strcpy(configFile, "configSample.txt");

	//
//	noOfTransRead = noOfTrans;

	//
//	strcpy(dataFile, "data2.txt");

	// 
//	topK = 2;
//	expectedK = 2;

//	noOfBatches = 2;
//	epsilon = 0.125;//0.25;

	//
	lossy_input(configFile);

	// calculate beta and no. of batches
	width = ceiling(1.0/epsilon);
	beta = ceiling(R/(double)width);
	noOfBatches = ceiling(noOfTransRead/(double)R);

	lossyMain(dataFile, noOfBatches, maxTransSize, epsilon, beta);

	
}

