
#include "trans.h"
#include "fptN20.h"
#include "fpt_topNeg.h"
#ifndef _WIN32
#include <sys/resource.h>
#include <sys/times.h>
#include <unistd.h>
#endif

int noOfSlot = 10001;
//int noOfSlot = 5;



FILE *debugFilePtr; 

double *supportThreshold;


transPtr readTrans(FILE *filePtr)
{
	transPtr returnValue;

	int i;

	returnValue = (transPtr) malloc(sizeof(trans));

	fscanf(filePtr, "%d", &(returnValue->noOfItem));

	returnValue->item = (int *) malloc(sizeof(int)*returnValue->noOfItem);

	for (i = 0; i < returnValue->noOfItem; i++)
	{
		fscanf(filePtr, " %d", &(returnValue->item[i]));
	}

	fscanf(filePtr, "\n");

	return returnValue;
}

transPtr *readData(char *filename, int noOfTrans)
{
	FILE *filePtr;
	transPtr *returnValue;
	int transNo;

	int i, j;

	transPtr tempValue;

	filePtr = (FILE *) fopen(filename, "r");
	if (filePtr == NULL)
	{
		printf("File %s cannot be opened!\n", filename);
		exit(0);
	}

	returnValue = (transPtr *) malloc(sizeof(transPtr)*noOfTrans);

	transNo = 0;

	// skip 
	tempValue = (transPtr) malloc(sizeof(trans));
	for (j = 0; j < noOfSkip; j++)
	{
		fscanf(filePtr, "%d", &(tempValue->noOfItem));

		tempValue->item = (int *) malloc(sizeof(int)*tempValue->noOfItem);

		for (i = 0; i < tempValue->noOfItem; i++)
		{
			fscanf(filePtr, " %d", &(tempValue->item[i]));
		}

		fscanf(filePtr, "\n");

		free(tempValue->item);
	}
	free(tempValue);
	

	//while (!feof(filePtr))
	for (j = 0; j < noOfTrans; j++)
	{
		returnValue[transNo] = (transPtr) malloc(sizeof(trans));

		fscanf(filePtr, "%d", &(returnValue[transNo]->noOfItem));

		returnValue[transNo]->item = (int *) malloc(sizeof(int)*returnValue[transNo]->noOfItem);

		for (i = 0; i < returnValue[transNo]->noOfItem; i++)
		{
			fscanf(filePtr, " %d", &(returnValue[transNo]->item[i]));
		}

		fscanf(filePtr, "\n");

		transNo++;
	}

	fclose(filePtr);

	return returnValue;
}

void sortItemOrderEach(entryPtr bomoResult, int noOfBOMOResult)
{
	int i, j;

	int *list;
	int *index;

	int size;

	if (noOfBOMOResult <= 0)
	{
		return;
	}

	size = bomoResult[0].itemsetSize;

	list = (int *) malloc(sizeof(int)*size);
	index = (int *) malloc(sizeof(int)*size);
	for (i = 0; i < size; i++)
	{
		index[i] = i;
	}

	for (i = 0; i < noOfBOMOResult; i++)
	{
		for (j = 0; j < size; j++)
		{
			list[j] = bomoResult[i].item[j];
		}

		quicksort_i(index, list, 0, size-1);
		
		for (j = 0; j < size; j++)
		{
			bomoResult[i].item[j] = list[size-j-1];
		}
	}

	free(list);
	free(index);
}

void sortItemOrder(entryPtr *bomoResult, int *noOfBOMOResult)
{
	int i;

	for (i = 0; i < expectedK; i++)
	{
		sortItemOrderEach(bomoResult[i], noOfBOMOResult[i]);
	}
}

void addEntry(entryPtr *bucket, int noOfPreEntry, int *itemset, int itemsetSize, int freq)
{
	entryPtr tempBucket;

	int i;

	entryPtr bucketProcess;
	int noOfEntryProcess;

	noOfEntryProcess = noOfPreEntry;

	bucketProcess = (*bucket);

	tempBucket = (entryPtr) malloc(sizeof(entry)*(noOfEntryProcess+1));

	for (i = 0; i < noOfEntryProcess; i++)
	{
		tempBucket[i].itemsetSize = bucketProcess[i].itemsetSize;
		tempBucket[i].item = bucketProcess[i].item;
		tempBucket[i].count = bucketProcess[i].count;

		tempBucket[i].isMark = bucketProcess[i].isMark;
	}

	tempBucket[noOfEntryProcess].itemsetSize = itemsetSize;
	//tempBucket[noOfEntryProcess].item = itemset;
	tempBucket[noOfEntryProcess].item = (int *) malloc(sizeof(int)*itemsetSize);
	memcpy(tempBucket[noOfEntryProcess].item, itemset, sizeof(int)*itemsetSize);
	tempBucket[noOfEntryProcess].count = freq;

	tempBucket[noOfEntryProcess].isMark = 1;

	if (noOfPreEntry > 0)
	{
		free(bucketProcess);
	}

	(*bucket) = tempBucket;
}


void removeEntry(entryPtr *bucket, int noOfPreEntry, int *itemset, int itemsetSize, int freq)
{
	entryPtr tempBucket;

	int i, j;

	entryPtr bucketProcess;
	int noOfEntryProcess;

	int count;

	int isSame;

	noOfEntryProcess = noOfPreEntry;

	bucketProcess = (*bucket);

	if (noOfEntryProcess-1 <= 0)
	{
		if (bucketProcess != NULL)
		{
			free(bucketProcess);
		}

		tempBucket = NULL;
	}
	else
	{
		tempBucket = (entryPtr) malloc(sizeof(entry)*(noOfEntryProcess-1));

		count = 0;
		for (i = 0; i < noOfEntryProcess; i++)
		{
			isSame = 1;
			for (j = 0; j < itemsetSize; j++)
			{
				if (itemset[j] != bucketProcess[i].item[j])
				{
					isSame = 0;
					break;
				}
			}

			if (isSame == 0)
			{

				tempBucket[count].itemsetSize = bucketProcess[i].itemsetSize;
				tempBucket[count].item = bucketProcess[i].item;
				tempBucket[count].count = bucketProcess[i].count;

				tempBucket[count].isMark = bucketProcess[i].isMark;

				count++;
			}
			else
			{
				free(bucketProcess[i].item);
			}
		}

		if (noOfPreEntry > 0)
		{
			free(bucketProcess);
		}
	}

	(*bucket) = tempBucket;
}

int factorial(int no)
{
	int i;

	int returnValue;

	returnValue = 1;

	for (i = 0; i < no; i++)
	{
		returnValue *= (i+1);
	}

	return returnValue;
}

int noOfCombination(int n, int r)
{
//	return factorial(n)/(factorial(r)*factorial(n-r));

	double no1;

	//double no2;

	int i;

	int returnValue;

	
	no1 = 1;
	//for (i = r+1; i <= n; i++)
	for (i = n; i >= r+1; i--)
	{
		no1 *= i/( (double) (n-i+1) );
	}
	//no2 = factorial(n-r);
	
	returnValue = (int) (no1 + 0.1);//no1/no2;

/*
	no1 = 1;
	for (i = r+1; i <= n; i++)
	{
		no1 *= i;
	}
	no2 = 1;
	for (i = 0; i < n-r; i++)
	{
		no2 *= (i+1);
	}

	returnValue = (int) (no1/no2 + 0.1);
*/
	

	return returnValue;
}

int **possibleItemset(int *trans, int transSize, int itemsetSize, int *noOfPossOutput)
{
	int *pointer;
	int i;

	int **returnValue;

	int count = 0;

	int temp = 0;

	int isFinish = 0;

	int no;

	if (itemsetSize > transSize)
	{
		(*noOfPossOutput) = 0;
		return NULL;
	}


	pointer = (int *) malloc(sizeof(int)*itemsetSize);

	for (i = 0; i < itemsetSize; i++)
	{
		pointer[i] = i;
	}

	(*noOfPossOutput) = noOfCombination(transSize, itemsetSize);

	returnValue = (int **) malloc(sizeof(int *)*(*noOfPossOutput));
	for (i = 0; i < (*noOfPossOutput); i++)
	{
		returnValue[i] = (int *) malloc(sizeof(int)*itemsetSize);
	}

	while (count < (*noOfPossOutput))
	{
		for (i = 0; i < itemsetSize; i++)
		{
			returnValue[count][i] = trans[pointer[i]];
		}
		count++;

		no = 0;
		do 
		{
			no++;
			temp = itemsetSize-no;
			if (temp < 0)
			{
				isFinish = 1;
				break;
			}
			pointer[temp]++;
		}
		while (pointer[temp]+itemsetSize-1-temp >= transSize);

		if (isFinish == 1)
		{
			// check whether it is the last
			//if (count == (*noOfPossOutput))
			//{
			//	printf("Right Result!\n");
			//}
			//else
			//{
			//	printf("Wrong Result!\n");
			//}
	
			break;
		}

		for (i = temp+1; i < itemsetSize; i++)
		{
			pointer[i] = pointer[temp]+(i-temp);
		}
				
	}

	free(pointer);

	return returnValue;
}

int maximum(int no1, int no2)
{
	if (no1 > no2)
	{
		return no1;
	}
	else
	{
		return no2;
	}
}

int roundUp(double no)
{
	int returnValue;

	if (no - ((int) no) == 0)
	{
		returnValue = (int) no;
	}
	else
	{
		returnValue = (int) (no + 1);
	}

	return returnValue;
}

int calculateOptimalObser(int maxTransSize, int itemsetSize, double sigma, double supportThreshold)
{
	int returnValue;

	double no;

	no = 2*(noOfCombination(maxTransSize, itemsetSize) + 4*log(2.0/sigma))/supportThreshold;

	// round up
	returnValue = roundUp(no);

	return returnValue;
}


int find_KthFrequent(entryPtr *hash, int *noOfHashEntry, int K)
{
	int i, j;

	int *startIndex;

	int **index;
	int **value;
	int max = 0;

	int lastMax = 0;

	int noOfProcess;

	int returnValue;
	int maxIndex;

	int noOfLook;

	startIndex = (int *) malloc(sizeof(int)*noOfSlot);
	index = (int **) malloc(sizeof(int *)*noOfSlot);
	value = (int **) malloc(sizeof(int *)*noOfSlot);

	memset(startIndex, 0, sizeof(int)*noOfSlot);

	// find the greatest value of no. of entry
	for (i = 0; i < noOfSlot; i++)
	{
		if (noOfHashEntry[i] > 0)
		{
			index[i] = (int *) malloc(sizeof(int)*noOfHashEntry[i]);
			value[i] = (int *) malloc(sizeof(int)*noOfHashEntry[i]);
	
			for (j = 0; j < noOfHashEntry[i]; j++)
			{
				index[i][j] = j;
				value[i][j] = hash[i][j].count;
			}

			// sort
			quicksort_i(index[i], value[i], 0, noOfHashEntry[i]-1);
		}
		else
		{
			index[i] = NULL;
			value[i] = NULL;
		}
	}
	
	noOfLook = 0;
	noOfProcess = 0;
	while (noOfProcess != K)
	{
		max = 0;
		maxIndex = -1;
		for (i = 0; i < noOfSlot; i++)
		{
			if ((startIndex[i] < noOfHashEntry[i]) && (value[i][startIndex[i]] > max))
			{
				max = value[i][startIndex[i]];
				maxIndex = i;

				lastMax = max;
			}
		}

		//if (noOfProcess == 1)
		//{
		//	f1 = max;
		//}

		if (maxIndex == -1)
		{
		}
		else
		{
			startIndex[maxIndex]++;
			
			noOfProcess++;

			if (noOfProcess == K)
			{
				returnValue = max;
			}
		}

		noOfLook++;
		if (noOfLook > K)
		{
			break;
		}
	}

	// free
	free(startIndex);
	for (i = 0; i < noOfSlot; i++)
	{
		if (index[i] != NULL)
		{
			free(index[i]);
		}
		if (value[i] != NULL)
		{
			free(value[i]);
		}
	}
	free(index);
	free(value);

	if (noOfLook > K)
	{
		//return -1;
		return lastMax;
	}
	else
	{
		return returnValue;
	}	
}

entryPtr find_output(entryPtr *hash, int *noOfHashEntry, int K, int *noOfOut, int arrayBound, int itemsetSize)
{
	entryPtr returnValue;

	int i, j;

	int *startIndex;

	int **index;
	int **value;
	int max = 0;

	int noOfProcess;

	int maxIndex;

	int noOfLook;

	//int tempNo;

	int *itemset;
	int startEnd;

	int preMax;

	int isFinish;

	//returnValue = (int **) malloc(sizeof(int *)*arrayBound);
	returnValue = (entryPtr) malloc(sizeof(entry)*arrayBound);

	startIndex = (int *) malloc(sizeof(int)*noOfSlot);
	index = (int **) malloc(sizeof(int *)*noOfSlot);
	value = (int **) malloc(sizeof(int *)*noOfSlot);

	memset(startIndex, 0, sizeof(int)*noOfSlot);

	// find the greatest value of no. of entry
	for (i = 0; i < noOfSlot; i++)
	{
		if (noOfHashEntry[i] > 0)
		{
			index[i] = (int *) malloc(sizeof(int)*noOfHashEntry[i]);
			value[i] = (int *) malloc(sizeof(int)*noOfHashEntry[i]);

			for (j = 0; j < noOfHashEntry[i]; j++)
			{
				index[i][j] = j;
				value[i][j] = hash[i][j].count;
			}

			// sort
			quicksort_i(index[i], value[i], 0, noOfHashEntry[i]-1);
		}
		else
		{
			index[i] = NULL;
			value[i] = NULL;
		}
	}
	
	noOfLook = 0;
	noOfProcess = 0;
	isFinish = 0;
	startEnd = 0;
	preMax = 0;
	while ((noOfProcess < K) || (isFinish == 0))
	{
		max = 0;
		maxIndex = -1;
		for (i = 0; i < noOfSlot; i++)
		{
			if ((startIndex[i] < noOfHashEntry[i]) && (value[i][startIndex[i]] > max))
			{
				max = value[i][startIndex[i]];
				maxIndex = i;

				itemset = hash[i][index[i][startIndex[i]]].item;
			}
		}

		if (startEnd == 1)
		{
			if (preMax == max)
			{
			}
			else
			{
				isFinish = 1;
				break;
			}
		}

		preMax = max;

		//if (noOfProcess == 1)
		//{
		//	f1 = max;
		//}

		if (maxIndex == -1)
		{
		}
		else
		{
			//tempNo = index[maxIndex][startIndex[maxIndex]];
			//returnValue[noOfProcess] = hash[maxIndex][tempNo].item;

			//returnValue[noOfProcess] = itemset;
			//finalCount[noOfProcess] = max;
			returnValue[noOfProcess].item = itemset;
			returnValue[noOfProcess].count = max;
			returnValue[noOfProcess].itemsetSize = itemsetSize;

			startIndex[maxIndex]++;
			
			noOfProcess++;

			if (noOfProcess == K)
			{
				//returnValue = max;

				startEnd = 1;
			}
		}

		noOfLook++;
		if ((noOfLook > K) && (isFinish == 1))
		{
			break;
		}

		if (noOfLook >= arrayBound)
		{
			break;
		}
	}

	(*noOfOut) = noOfProcess;

	// free
	free(startIndex);
	for (i = 0; i < noOfSlot; i++)
	{
		if (index[i] != NULL)
		{
			free(index[i]);
		}
		if (value[i] != NULL)
		{
			free(value[i]);
		}
	}
	free(index);
	free(value);

	if (noOfLook > K)
	{
		//return -1;
		//return NULL;
		return returnValue;
	}
	else
	{
		return returnValue;
	}	
}

double calculateRunningError(double supportThreshold, double sigma, int transNo)
{
	double returnValue;

	returnValue = sqrt( (2*supportThreshold*log(2.0/sigma))/( (double) transNo + 1.0) );

	return returnValue;
}

// remove itemset with freq < cutThresholdCount
void removeInfrequent(entryPtr *hash, int *noOfHashEntry, int cutThresholdCount)
{
	int i, j;

	int *remainCount;

	entryPtr *oldHash;

	int no;

	remainCount = (int *) malloc(sizeof(int)*noOfSlot);
	memset(remainCount, 0, sizeof(int)*noOfSlot);

	// count the no. remains
	for (i = 0; i < noOfSlot; i++)
	{
		for (j = 0; j < noOfHashEntry[i]; j++)
		{
			if (hash[i][j].count >= cutThresholdCount)
			{
				remainCount[i]++;
			}
		}
	}

	// clone the old hash
	oldHash = (entryPtr *) malloc(sizeof(entryPtr)*noOfSlot);
	for (i = 0; i < noOfSlot; i++)
	{
		oldHash[i] = hash[i];
	}

	// create the new hash and remove the infreq itemsets
	for (i = 0; i < noOfSlot; i++)
	{
		if (remainCount[i] == 0)
		{
			hash[i] = NULL;
		}
		else
		{
			hash[i] = (entryPtr) malloc(sizeof(entry)*remainCount[i]);

			no = 0;
	
			for (j = 0; j < noOfHashEntry[i]; j++)
			{
				if (oldHash[i][j].count >= cutThresholdCount)
				{
					hash[i][no].count = oldHash[i][j].count;
					hash[i][no].item = oldHash[i][j].item;
					hash[i][no].itemsetSize = oldHash[i][j].itemsetSize;
					no++;
				}
				else
				{
					// free the itemset
					free(oldHash[i][j].item);
				}
			}
			
		}

		noOfHashEntry[i] = remainCount[i];
	}


	

	// free
	for (i = 0; i < noOfSlot; i++)
	{
		if (oldHash[i] != NULL)
		{
			free(oldHash[i]);
		}
	}
	free(oldHash);

	free(remainCount);
}

void topNeg_doMainStep(int transNo, entryPtr *hash, int *noOfHashEntry, int *itemset, int itemsetSize, int *n0, int n1)
{


	int i, j;

	int totalEntry;

	int hashValue;


	double runningError;

	int cutThresholdCount;

	int supportCount;

	int isSame = 0;

	// calculate the hash value
	hashValue = 0;
	for (i = 0; i < itemsetSize; i++)
	{
		hashValue += itemset[i];
	}
	hashValue = hashValue%noOfSlot;



	// check whether the itemset is in the storage
	for (i = 0; i < noOfHashEntry[hashValue] ; i++)
	{
		//printf("fjskal");
		isSame = 1;
		if (itemsetSize == hash[hashValue][i].itemsetSize)
		{
			for (j = 0; j < itemsetSize; j++)
			{
				if (itemset[j] != hash[hashValue][i].item[j])
				{
					isSame = 0;
					break;
				}
			}
		}
		else
		{
			isSame = 0;
		}

		// if exist in the hash
		if (isSame == 1)
		{
			// increment the count
			hash[hashValue][i].count++;
			break;
		}
	}
//if (itemsetSize == 2)
//printf("           isSame (%d) (%d %d) : %d\n", itemsetSize, itemset[0], itemset[1], isSame);
	// if not exist in the hash
	if (isSame == 0)
	{
		// calculate total no. of entry
		totalEntry = 0;
		for (i = 0; i < noOfSlot; i++)
		{
			totalEntry += noOfHashEntry[i];
		}

		// check whether the storage is larger than n0
		//if (totalEntry > (*n0))
		//if ((totalEntry > n0[itemsetSize-1]) && (transNo + 1 > n0[itemsetSize-1]))
		if ((totalEntry > n0[itemsetSize-1]) && (transNo + 1 > n0[itemsetSize-1]))
		{
			//supportCount = find_KthFrequent(hash, noOfHashEntry, n1);
			//supportThreshold = supportCount/((double) transNo);

			// find the support threshold (again)
			supportCount = find_KthFrequent(hash, noOfHashEntry, topK+D);
			supportThreshold[itemsetSize-1] = supportCount/((double) (transNo+1));

			// calculate running e
			runningError = calculateRunningError(supportThreshold[itemsetSize-1], sigma, transNo);
				
			// delete all entries in the storage that are potentially infrequent
			printf("  No %d: Deleting infreq. itemsets (Size %d)...", transNo, itemsetSize);
			fprintf(debugFilePtr, "  No %d: Deleting infreq. itemsets (Size %d)...", transNo, itemsetSize);

			cutThresholdCount = roundUp((supportThreshold[itemsetSize-1]-2*runningError)*(transNo+1));

			printf(" support (in Fraction) = %.4f\n", supportThreshold[itemsetSize-1]-2*runningError);
			fprintf(debugFilePtr, " support (in Fraction) = %.4f\n", supportThreshold[itemsetSize-1]-2*runningError);

			printf("                   threshold: %d (before) ", cutThresholdCount);
			fprintf(debugFilePtr, "                   threshold: %d (before) ", cutThresholdCount);
			if (cutThresholdCount < 0)
			{
				cutThresholdCount = 0;
			}
			printf("%d (after)\n", cutThresholdCount);
			fprintf(debugFilePtr, "%d (after)\n", cutThresholdCount);

			printf("                    noOfEntry = %d  and  n0 = %d\n", totalEntry, n0[itemsetSize-1]);
			fprintf(debugFilePtr, "                    noOfEntry = %d  and  n0 = %d\n", totalEntry, n0[itemsetSize-1]);

			printf("                    supportThreshold:%.6f\n", supportThreshold[itemsetSize-1]);
			fprintf(debugFilePtr, "                    supportThreshold:%.6f\n", supportThreshold[itemsetSize-1]);

			printf("                    running error %.6f\n", runningError);
			fprintf(debugFilePtr, "                    running error %.6f\n", runningError);

			removeInfrequent(hash, noOfHashEntry, cutThresholdCount);

			// calculate total no. of entry
			totalEntry = 0;
			for (i = 0; i < noOfSlot; i++)
			{
				totalEntry += noOfHashEntry[i];
			}
			printf("                    noOfEntry (after) = %d  and  n0 = %d\n", totalEntry, n0[itemsetSize-1]);
			fprintf(debugFilePtr, "                    noOfEntry (after) = %d  and  n0 = %d\n", totalEntry, n0[itemsetSize-1]);

		}

		// insert e with an inital count 1 
		addEntry(&(hash[hashValue]), noOfHashEntry[hashValue], itemset, itemsetSize, 1);
		noOfHashEntry[hashValue]++;
		

	}

}


void printHash(FILE *filePtr, entryPtr *hash, int *noOfHashEntry, int itemsetSize)
{
	int i, j, k;

	for (i = 0; i < noOfSlot; i++)
	{
		//printf("  Slot %d\n", i);
		//printf("  --------\n");
//		fprintf(filePtr, "  Slot %d\n", i);
//		fprintf(filePtr, "  --------\n");
		for (j = 0; j < noOfHashEntry[i]; j++)
		{
			//printf("    ");
//			fprintf(filePtr, "    ");
			for (k = 0; k < hash[i][j].itemsetSize; k++)
			{
				//printf("%d ", hash[i][j].item[k]);
//				fprintf(filePtr, "%d ", hash[i][j].item[k]);
			}
			//printf("\t\t%d\n", hash[i][j].count);
//			fprintf(filePtr, "\t\t%d\n", hash[i][j].count);
		}
	}
}

// 1 : same
// 0 : difference
int compareItemsetSize(int itemSize, int *itemset1, int *itemset2)
{
	int i;

	int returnValue;

	returnValue = 1;
	for (i = 0; i < itemSize; i++)
	{
		if (itemset1[i] != itemset2[i])
		{
			returnValue = 0;
			break;
		}
	}
	return returnValue;
}

// 1 : exist in the set
// 0 : not exist in the set
int compareItemset(entryPtr testResult, int testIndex, entryPtr setElt, int noOfSetElt)
{
	int i;

	int returnValue; 

	int isSame;

	returnValue = 0;

	for (i = 0; i < noOfSetElt; i++)
	{
		if (testResult[testIndex].itemsetSize == setElt[i].itemsetSize)
		{

			isSame = compareItemsetSize(testResult[testIndex].itemsetSize, testResult[testIndex].item, setElt[i].item);

			if (isSame == 1)
			{
				returnValue = 1;
				break;
			}

		}
	}

	return returnValue;
}

int compareFalsePos(entryPtr finalResult, int noOfFinal, entryPtr bomoResult, int noOfBOMOResult)
{
	int returnValue = 0;

	int i;


	for (i = 0; i < noOfFinal; i++)
	{
		if (compareItemset(finalResult, i, bomoResult, noOfBOMOResult) == 0)
		{
			returnValue++;
		}
	}

	return returnValue;
}

int compareFalseNeg(entryPtr finalResult, int noOfFinal, entryPtr bomoResult, int noOfBOMOResult)
{
	int returnValue = 0;

	int i;

	for (i = 0; i < noOfBOMOResult; i++)
	{
		if (compareItemset(bomoResult, i, finalResult, noOfFinal) == 0)
		{
			returnValue++;
		}
	}

	return returnValue;
}


void compareResult(entryPtr *finalResult, int *noOfFinal, entryPtr *bomoResult, int *noOfBOMOResult, int *noOfFalsePos, int *noOfFalseNeg)
{
	int i;

	for (i = 0; i < expectedK; i++)
	{
		noOfFalsePos[i] = compareFalsePos(finalResult[i], noOfFinal[i], bomoResult[i], noOfBOMOResult[i]);
		noOfFalseNeg[i] = compareFalseNeg(finalResult[i], noOfFinal[i], bomoResult[i], noOfBOMOResult[i]);
	}
}



entryPtr *findPotentialFrequent(int startIndex, int endIndex, int *noOfTopK, int *n0, int *largerTopK)
{
	entryPtr *tempReturn;

	entryPtr *returnValue;

	int topKValue;

	int i, j;

	int supportCount;
	double supportThreshold;

	int bucketSize;

	double runningError;

	int cutThresholdCount;

	int noOfCount;


	returnValue = (entryPtr *) malloc(sizeof(entryPtr)*expectedK);

	bucketSize = endIndex-startIndex+1;

	topKValue = largerTopK[expectedK-1]*1000; //*1000

	printf("  Finding potential frequ....\n");
	fprintf(debugFilePtr, "  Finding potential frequ....\n");


	//entryPtr *processBOMO(char *configFilename, int startIndex, int bucketSize, int topK, int L, int *noOfTopK);
	tempReturn = processBOMO(configFile, startIndex, bucketSize, topKValue, expectedK, noOfTopK);

	// sort the result
	sortItemOrder(tempReturn, noOfTopK);

	for (i = 0; i < expectedK; i++)
	{

		if (noOfTopK[i] >= largerTopK[i])
		{
			// find the support
			supportCount = tempReturn[i][largerTopK[i]-1].count;
			supportThreshold = supportCount/((double) (bucketSize));

			runningError = calculateRunningError(supportThreshold, sigma, bucketSize);

			cutThresholdCount = roundUp((supportThreshold-2*runningError)*bucketSize);
			if (cutThresholdCount < 0)
			{
				cutThresholdCount = 0;
			}
			printf("    cutThresholdCount: %d (Size %d)\n", cutThresholdCount, i+1);
			fprintf(debugFilePtr, "    cutThresholdCount: %d (Size %d)\n", cutThresholdCount, i+1);


			// calculate the no. of counts
			noOfCount = 0;
			for (j = 0; j < noOfTopK[i]; j++)
			{
				if (tempReturn[i][j].count >= cutThresholdCount)
				{
					noOfCount++;
				}
			}

			printf("    no. of itemsets stored in batch (Size %d):%d\n", i+1, noOfCount);
			fprintf(debugFilePtr, "    no. of itemsets stored in batch (Size %d):%d\n", i+1, noOfCount);

			if (noOfCount == noOfTopK[i])
			{
				//printf("****************may have PROBLEM!(Size %d) (no. of topK found:%d)*************\n", i+1, noOfTopK[i]);
				//fprintf(debugFilePtr, "****************may have PROBLEM!(Size %d) (no. of topK found:%d)*************\n", i+1, noOfTopK[i]);
			}

			// keep the remaining
			returnValue[i] = (entryPtr) malloc(sizeof(entry)*noOfCount);
			for (j = 0; j < noOfTopK[i]; j++)
			{
				if (tempReturn[i][j].count >= cutThresholdCount)
				{
					returnValue[i][j].count = tempReturn[i][j].count;
					returnValue[i][j].itemsetSize = tempReturn[i][j].itemsetSize;
					returnValue[i][j].item = tempReturn[i][j].item;
				}
				else
				{
					free(tempReturn[i][j].item);
				}
			}

			noOfTopK[i] = noOfCount;

		}
		else
		{
			if (noOfTopK[i] > 0)
			{
				returnValue[i] = (entryPtr) malloc(sizeof(entry)*noOfTopK[i]);
			}
			else
			{
				returnValue[i] = NULL;
				noOfTopK[i] = 0;
			}

			for (j = 0; j < noOfTopK[i]; j++)
			{
				returnValue[i][j].count = tempReturn[i][j].count;
				returnValue[i][j].itemsetSize = tempReturn[i][j].itemsetSize;
				returnValue[i][j].item = tempReturn[i][j].item;
			}
		}

		free(tempReturn[i]);
	}

	free(tempReturn);

	return returnValue;
}

void removePotentialInfrequent(entryPtr *setF, int *noOfSetFEntry, int itemsetSize, int transNo, int *n0, int largerTopK)
{
	int totalEntry;

	int i;

	int supportCount;

	double runningError;

	int cutThresholdCount;

	totalEntry = 0;

	for (i = 0; i < noOfSlot; i++)
	{
		totalEntry += noOfSetFEntry[i];
	}

	if (totalEntry > n0[itemsetSize-1])
	{
		// remove 
		//supportCount = find_KthFrequent(hash, noOfHashEntry, n1);
		//supportThreshold = supportCount/((double) transNo);

		// find the support threshold (again)
		supportCount = find_KthFrequent(setF, noOfSetFEntry, largerTopK);
		supportThreshold[itemsetSize-1] = supportCount/((double) (transNo+1));

		// calculate running e
		runningError = calculateRunningError(supportThreshold[itemsetSize-1], sigma, transNo);
				
		// delete all entries in the storage that are potentially infrequent
		printf("  No %d: Deleting infreq. itemsets (Size %d)...", transNo, itemsetSize);
		fprintf(debugFilePtr, "  No %d: Deleting infreq. itemsets (Size %d)...", transNo, itemsetSize);

		cutThresholdCount = roundUp((supportThreshold[itemsetSize-1]-2*runningError)*(transNo+1));

		printf(" support (in Fraction) = %.4f\n", supportThreshold[itemsetSize-1]-2*runningError);
		fprintf(debugFilePtr, " support (in Fraction) = %.4f\n", supportThreshold[itemsetSize-1]-2*runningError);

		printf("                   threshold: %d (before) ", cutThresholdCount);
		fprintf(debugFilePtr, "                   threshold: %d (before) ", cutThresholdCount);
		if (cutThresholdCount < 0)
		{
			cutThresholdCount = 0;
		}
		printf("%d (after)\n", cutThresholdCount);
		fprintf(debugFilePtr, "%d (after)\n", cutThresholdCount);

		printf("                    noOfEntry = %d  and  n0 = %d\n", totalEntry, n0[itemsetSize-1]);
		fprintf(debugFilePtr, "                    noOfEntry = %d  and  n0 = %d\n", totalEntry, n0[itemsetSize-1]);

		printf("                    supportThreshold:%.6f\n", supportThreshold[itemsetSize-1]);
		fprintf(debugFilePtr, "                    supportThreshold:%.6f\n", supportThreshold[itemsetSize-1]);

		printf("                    running error %.6f\n", runningError);
		fprintf(debugFilePtr, "                    running error %.6f\n", runningError);

		removeInfrequent(setF, noOfSetFEntry, cutThresholdCount);

		// calculate total no. of entry
		totalEntry = 0;
		for (i = 0; i < noOfSlot; i++)
		{
			totalEntry += noOfSetFEntry[i];
		}
		printf("                    noOfEntry (after) = %d  and  n0 = %d\n", totalEntry, n0[itemsetSize-1]);
		fprintf(debugFilePtr, "                    noOfEntry (after) = %d  and  n0 = %d\n", totalEntry, n0[itemsetSize-1]);

		
	}
}


// 1 :true
// 0 :false
// Asssume sorted elt
int isContain(transPtr transaction, int *elt, int noOfElt)
{
	int i;

	int curr = 0;

	for (i = 0; i < transaction->noOfItem; i++)
	{
		
		if (elt[curr] == transaction->item[i])
		{
			curr++;

			if (curr == noOfElt)
			{
				return 1;
			}
		}
		else if (elt[curr] < transaction->item[i])
		{
			return 0;
		}
	}

	return 0;
}

int findCountBatch(int *itemset, int size, char *dataFile, int startIndex, int endIndex)
{
	FILE *filePtr;

	int returnValue;

	int i, j;

	int noOfTrans;

	int noOfSkip;

	transPtr tempValue;

	filePtr = (FILE *) fopen(dataFile, "r");
	if (filePtr == NULL)
	{
		printf("File %s does not exist!\n", dataFile);
		exit(1);
	}
	
	tempValue = (transPtr) malloc(sizeof(trans));

	// skip
	noOfSkip = startIndex;
	for (j = 0; j < noOfSkip; j++)
	{
		fscanf(filePtr, "%d", &(tempValue->noOfItem));
		tempValue->item = (int *) malloc(sizeof(int)*tempValue->noOfItem);

		for (i = 0; i < tempValue->noOfItem; i++)
		{
			fscanf(filePtr, " %d", &(tempValue->item[i]));
		}

		fscanf(filePtr, "\n");



		free(tempValue->item);
	}

	noOfTrans = endIndex - startIndex + 1;

	returnValue = 0;
	for (j = 0;  j < noOfTrans; j++)
	{
		fscanf(filePtr, "%d", &(tempValue->noOfItem));
		tempValue->item = (int *) malloc(sizeof(int)*tempValue->noOfItem);

		for (i = 0; i < tempValue->noOfItem; i++)
		{
			fscanf(filePtr, " %d", &(tempValue->item[i]));
		}

		fscanf(filePtr, "\n");


		// check whether the itemset inside in this trans
		if (isContain(tempValue, itemset, size) == 1)
		{
			returnValue++;
		}

		free(tempValue->item);		
	}

	free(tempValue);

	fclose(filePtr);

	return returnValue;
}

void markZero(entryPtr *setF, int *noOfSetFEntry)
{
	int i, j;

	for (i = 0; i < noOfSlot; i++)
	{
		for (j = 0; j < noOfSetFEntry[i]; j++)
		{
			setF[i][j].isMark = 0;
		}
	}
}

void findCountWithZeroMark(entryPtr *setF, int *noOfSetFEntry, char *dataFile, int itemsetSize, int startIndex, int endIndex, entryPtr *pool, int *noOfTopKPool)
{
	int i, j, k;

	int count;

	int **itemset;
	int noOfItemset;

	int bucketSize;

	int *newCount;

	int hashValue;

	entryPtr *listNode;
//int index_new;
	noOfItemset = 0;
	for (i = 0; i < noOfSlot; i++)
	{
		for (j = 0; j < noOfSetFEntry[i]; j++)
		{
			if (setF[i][j].isMark == 0)
			{

				// find the count
/*				count = findCountBatch(setF[i][j].item, setF[i][j].itemsetSize, dataFile, startIndex, endIndex);
//printf("  ~~~~~~~~~~~~~~~~~~~~~~~~~counting (size:%d, count:%d)...\n", setF[i][j].itemsetSize, count);
				setF[i][j].count += count;
*/
				noOfItemset++;
			}
		}
	}

	if (noOfItemset > 0)
	{
		itemset = (int **) malloc(sizeof(int *)*noOfItemset);
		for (i = 0; i < noOfItemset; i++)
		{
			itemset[i] = (int *) malloc(sizeof(int)*itemsetSize);
		}
		listNode = (entryPtr *) malloc(sizeof(entryPtr)*noOfItemset);

		count = 0;
		for (i = 0; i < noOfSlot; i++)
		{
			for (j = 0; j < noOfSetFEntry[i]; j++)
			{
				if (setF[i][j].isMark == 0)
				{

					for (k = 0; k < itemsetSize; k++)
					{
						itemset[count][k] = setF[i][j].item[k];
					}

//{
//int itemsetNew[2];
//if (itemsetSize == 2)
//{
//itemsetNew[0] = 127;
//itemsetNew[1] = 221;
//if ((itemsetNew[0] == itemset[count][0]) && (itemsetNew[1] == itemset[count][1]))
//{
//printf(" #######################3 indexCount : %d", count);
//fprintf(debugFilePtr, " #######################3 indexCount : %d", count);
//index_new = count;
//}
//}
//}


					listNode[count] = &(setF[i][j]);

					count++;
				}
			}
		}


		bucketSize = endIndex - startIndex + 1;
		//int *buildTreeSet(int **itemset, int noOfItemset, int itemsetSize, int startIndex, int bucketSize)
		newCount = buildTreeSet(itemset, noOfItemset, itemsetSize, startIndex, bucketSize);

//{
//if ((itemsetSize == 2) && (index_new < noOfItemset))
//{
//printf(" - newCount: %d\n", newCount[index_new]);
//fprintf(debugFilePtr, " - newCount: %d\n", newCount[index_new]);
//}
//}
		for (i = 0; i < noOfItemset; i++)
		{
			listNode[i]->count += newCount[i];

			if (newCount[i] != 0)
			{
				// calculate the hashValue
				hashValue = 0;
				for (j = 0; j < listNode[i]->itemsetSize; j++)
				{
					hashValue += listNode[i]->item[j];
				}
				hashValue = hashValue%noOfSlot;

			
				addEntry(&(pool[hashValue]), noOfTopKPool[hashValue], listNode[i]->item, listNode[i]->itemsetSize, newCount[i]);
				noOfTopKPool[hashValue]++;
			}

		}
	
		free(newCount);
		free(listNode);
		

		for (i = 0; i < noOfItemset; i++)
		{
			free(itemset[i]);
		}
		free(itemset);

		
	}

}


void printItemsetCount(FILE *filePtr, entryPtr *setF, int *noOfSetFEntry, int *itemset, int itemsetSize)
{
	int hashValue;
	int j, k;

	int isSame;

	hashValue = 0;
	for (j = 0; j < itemsetSize; j++)
	{
		hashValue += itemset[j];
	}
	hashValue = hashValue%noOfSlot;

	printf("##### Itemset ");
	fprintf(filePtr, "##### Itemset ");
	for (k = 0; k < itemsetSize; k++)
	{
		printf("%d ", itemset[k]);
		fprintf(filePtr, "%d ", itemset[k]);
	}
	

	for (j = 0; j < noOfSetFEntry[hashValue]; j++)
	{
		isSame = 1;
		if (itemsetSize == setF[hashValue][j].itemsetSize)
		{
			for (k = 0; k < itemsetSize; k++)
			{
				//if (itemset[k] != setF[hashValue][j].item[k])
				if (itemset[k] != setF[hashValue][j].item[k])
				{
					isSame = 0;
					break;
				}
			}
		}
		else
		{
			isSame = 0;
		}

		// if exist in the hash
		if (isSame == 1)
		{
			printf(" - count : %d\n", setF[hashValue][j].count);
			fprintf(filePtr, " - count : %d\n", setF[hashValue][j].count);
			
			break;
		}		
	}

	if (isSame == 0)
	{
		printf(" does not exist!\n");
		fprintf(filePtr, " does not exist!\n");
	}
}

void addToSetF(entryPtr *setF, int *noOfSetFEntry, entryPtr pool, int noOfPoolEntry, int itemsetSize)
{
	int i, j, k;

	int hashValue;

	int isSame;

	for (i = 0; i < noOfPoolEntry; i++)
	{

		// calculate the hash value
		hashValue = 0;
		for (j = 0; j < itemsetSize; j++)
		{
			hashValue += pool[i].item[j];
		}
		hashValue = hashValue%noOfSlot;


		isSame = 0;
		// check whether the itemset is in the storage
		for (j = 0; j < noOfSetFEntry[hashValue] ; j++)
		{
			//printf("fjskal");
			isSame = 1;
			if (itemsetSize == setF[hashValue][j].itemsetSize)
			{
				for (k = 0; k < itemsetSize; k++)
				{
					//if (itemset[k] != setF[hashValue][j].item[k])
					if (pool[i].item[k] != setF[hashValue][j].item[k])
					{
						isSame = 0;
						break;
					}
				}
			}
			else
			{
				isSame = 0;
			}

			// if exist in the hash
			if (isSame == 1)
			{
				// increment the count
				//hash[hashValue][j].count++;
				setF[hashValue][j].count += pool[i].count;

				setF[hashValue][j].isMark = 1;
				break;
			}
		}

		// if not exist in the hash
		if (isSame == 0)
		{
			// insert e with count
			addEntry(&(setF[hashValue]), noOfSetFEntry[hashValue], pool[i].item, itemsetSize, pool[i].count);
			noOfSetFEntry[hashValue]++;
		}
	}

}


void removeFromSetF(entryPtr *setF, int *noOfSetFEntry, entryPtr *pool, int *noOfPoolEntry, int itemsetSize)
{
	int i, j, k, l;

	int isSame;
	
	for (i = 0; i < noOfSlot; i++)
	{
//if ( (i == 3) && (itemsetSize == 2))
//printf("dlajdf\n");
		for (j = 0; j < noOfPoolEntry[i]; j++)
		{
			isSame = 0;
			// check whether the itemset is in the storage
			for (k = 0; k < noOfSetFEntry[i] ; k++)
			{
				//printf("fjskal");
				isSame = 1;
				if (itemsetSize == setF[i][k].itemsetSize)
				{
					for (l = 0; l < itemsetSize; l++)
					{
						//if (itemset[k] != setF[hashValue][j].item[k])
						if (pool[i][j].item[l] != setF[i][k].item[l])
						{
							isSame = 0;
							break;
						}
					}
				}
				else
				{
					isSame = 0;
				}
				
				// if exist in the hash
				if (isSame == 1)
				{
					// increment the count
					//hash[hashValue][j].count++;
					setF[i][k].count -= pool[i][j].count;
					
					setF[i][k].isMark = 1;
					
					if (setF[i][k].count <= 0)
					{
						removeEntry(&(setF[i]), noOfSetFEntry[i], pool[i][j].item, itemsetSize, 0);
						noOfSetFEntry[i]--;
					}
					break;
				}
			}
			
			// if not exist in the hash
			if (isSame == 0)
			{
				// insert e with count
				//addEntry(&(setF[hashValue]), noOfSetFEntry[hashValue], pool[i].item, itemsetSize, pool[i].count);
				//noOfSetFEntry[hashValue]++;
				
				//removeEntry(&(setF[hashValue]), noOfSetFEntry[hashValue], pool[i].item, itemsetSize, pool[i].count);
				//noOfSetFEntry[hashValue]--;
				
				printf("~~~~~ have error(Size %d)!\n", itemsetSize);
				fprintf(debugFilePtr, "~~~~~ have error(Size %d)!      ", itemsetSize);
				for (k = 0; k <itemsetSize; k++)
				{
					fprintf(debugFilePtr,  "%d ", pool[i][j].item[k]);
				}
				fprintf(debugFilePtr, "\n");
			}
		}
	}

	/*
	for (i = 0; i < noOfPoolEntry; i++)
	{

		// calculate the hash value
		hashValue = 0;
		for (j = 0; j < itemsetSize; j++)
		{
			hashValue += pool[i].item[j];
		}
		hashValue = hashValue%noOfSlot;


		isSame = 0;
		// check whether the itemset is in the storage
		for (j = 0; j < noOfSetFEntry[hashValue] ; j++)
		{
			//printf("fjskal");
			isSame = 1;
			if (itemsetSize == setF[hashValue][j].itemsetSize)
			{
				for (k = 0; k < itemsetSize; k++)
				{
					//if (itemset[k] != setF[hashValue][j].item[k])
					if (pool[i].item[k] != setF[hashValue][j].item[k])
					{
						isSame = 0;
						break;
					}
				}
			}
			else
			{
				isSame = 0;
			}

			// if exist in the hash
			if (isSame == 1)
			{
				// increment the count
				//hash[hashValue][j].count++;
				setF[hashValue][j].count -= pool[i].count;

				setF[hashValue][j].isMark = 1;

				if (setF[hashValue][j].count == 0)
				{
					removeEntry(&(setF[hashValue]), noOfSetFEntry[hashValue], pool[i].item, itemsetSize, 0);
					noOfSetFEntry[hashValue]--;
				}
				break;
			}
		}


		// if not exist in the hash
		if (isSame == 0)
		{
			// insert e with count
			//addEntry(&(setF[hashValue]), noOfSetFEntry[hashValue], pool[i].item, itemsetSize, pool[i].count);
			//noOfSetFEntry[hashValue]++;

			//removeEntry(&(setF[hashValue]), noOfSetFEntry[hashValue], pool[i].item, itemsetSize, pool[i].count);
			//noOfSetFEntry[hashValue]--;

			printf("~~~~~ have error!\n");
		}
	}
*/
}


entryPtr **createNewPool(entryPtr *pool, int *noOfTopKPool, int **noOfTopKNewPool)
{
	entryPtr **returnValue;

	int hashValue;

	int i, j, k;

	returnValue = (entryPtr **) malloc(sizeof(entryPtr *)*expectedK);
	for (i = 0; i < expectedK; i++)
	{
		returnValue[i] = (entryPtr *) malloc(sizeof(entryPtr)*noOfSlot);
		for (j = 0; j < noOfSlot; j++)
		{
			returnValue[i][j] = NULL;
		}

		memset(noOfTopKNewPool[i], 0, sizeof(int)*noOfSlot);

		//for (j = 0; j < noOfSlot; j++)
		//{
		//	noOfTopKNewPool[i][j] = 0;
		//}

		

		for (j = 0; j < noOfTopKPool[i]; j++)
		//for (j = 0; j < 0; j++)
		{

			// calculate the hash value
			hashValue = 0;
			for (k = 0; k < pool[i][j].itemsetSize; k++)
			{
				hashValue += pool[i][j].item[k];
			}
			hashValue = hashValue%noOfSlot;

//if (hashValue == 5)
//{
//	printf("lfda\n");
//}
//if (noOfTopKNewPool[i][hashValue] > 1000)
//{
//printf("jfdlaf\n");
//}
//ray
			addEntry(&(returnValue[i][hashValue]), noOfTopKNewPool[i][hashValue], pool[i][j].item, pool[i][j].itemsetSize, pool[i][j].count);
			noOfTopKNewPool[i][hashValue]++;
		}

	}

	return returnValue;
}

void topNeg_process()
{

	int *n0;
	int n1, n2;

	int i, l, j, k;

	//int **output;

	FILE *dataFilePtr;

	int supportCount;
	//double supportThreshold;

	//transPtr trans;

	//int noOfOutput;

	int itemsetSize;

	entryPtr *finalResult;

	//entryPtr **hash;
	//int **noOfHashEntry;

	entryPtr *bomoResult;
	int *noOfBOMOResult;

	int arrayBound;

	int *noOfFinal;

	int *noOfFalseNeg;
	int *noOfFalsePos;

	int *stored;

	double runningError;

	int b0;

	entryPtr *pool;	

	entryPtr **newPool;
	int **noOfTopKNewPool;

	entryPtr **setF;
	int **noOfSetFEntry;
	int *noOfTopKPool;

	entryPtr ***setQ;
	int ***noOfSetQEntry;

	int *largerTopK;

	int startIndex, endIndex;

	int noOfBatchProcess;

#ifndef _WIN32
 float  userTime, sysTime;
 struct rusage myTime1, myTime2;
 //struct rusage myTime3, myTime4;
 FILE *timeFilePtr;
 //FILE *timeFilePtr2;

#endif

	debugFilePtr = (FILE *) fopen("debug.txt", "w");

	stored = (int *) malloc(sizeof(int)*expectedK);
	memset(stored, 0, sizeof(int)*expectedK);

	supportThreshold = (double *) malloc(sizeof(double)*expectedK);
	memset(supportThreshold, 0, sizeof(double)*expectedK);

	//hash = (entryPtr **) malloc(sizeof(entryPtr *)*expectedK);
	//for (i = 0; i < expectedK; i++)
	//{
	//	hash[i] = (entryPtr *) malloc(sizeof(entryPtr)*noOfSlot);
	//	for (j = 0; j < noOfSlot; j++)
	//	{
	//		hash[i][j] = NULL;
	//	}
	//}

	//noOfHashEntry = (int **) malloc(sizeof(int *)*expectedK);
	//for (i = 0; i < expectedK; i++)
	//{
	//	noOfHashEntry[i] = (int *) malloc(sizeof(int)*noOfSlot);
	//	memset(noOfHashEntry[i], 0, sizeof(int)*noOfSlot);
	//}

	dataFilePtr = (FILE *) fopen(dataFile, "r");
	if (dataFilePtr == NULL)
	{
		printf("File %s cannot be opened!\n", dataFile);
		exit(0);
	}



#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime1);	
#endif

	//n1 = topK+D;
	n1 = R;
	n0 = (int *) malloc(sizeof(int)*expectedK);
	for (l = 0; l < expectedK; l++)
	{
		n0[l] = n1;
	}

	noOfTopKPool = (int *) malloc(sizeof(int)*expectedK);
	memset(noOfTopKPool, 0, sizeof(int)*expectedK);

	setF = (entryPtr **) malloc(sizeof(entryPtr *)*expectedK);
	for (i = 0; i < expectedK; i++)
	{
		setF[i] = (entryPtr *) malloc(sizeof(entryPtr)*noOfSlot);
		for (j = 0; j < noOfSlot; j++)
		{
			setF[i][j] = NULL;
		}
	}

	noOfSetFEntry = (int **) malloc(sizeof(int *)*expectedK);
	for (i = 0; i < expectedK; i++)
	{
		noOfSetFEntry[i] = (int *) malloc(sizeof(int)*noOfSlot);
		memset(noOfSetFEntry[i], 0, sizeof(int)*noOfSlot);
	}

	setQ = (entryPtr ***) malloc(sizeof(entryPtr **)*(noOfBatch+1));
	for (i = 0; i < noOfBatch+1; i++)
	{
		setQ[i] = (entryPtr **) malloc(sizeof(entryPtr *)*expectedK);
		for (j = 0; j < expectedK; j++)
		{
			setQ[i][j] = (entryPtr *) malloc(sizeof(entryPtr)*noOfSlot);
			for (k = 0; k < noOfSlot; k++)
			{
				setQ[i][j][k] = NULL;
			}
		}
	}

	noOfSetQEntry = (int ***) malloc(sizeof(int **)*(noOfBatch+1));
	for (i = 0; i < noOfBatch+1; i++)
	{
		noOfSetQEntry[i] = (int **) malloc(sizeof(int *)*expectedK);
		for (j = 0; j < expectedK; j++)
		{
			noOfSetQEntry[i][j] = (int *) malloc(sizeof(int)*noOfSlot);
			memset(noOfSetQEntry[i][j], 0, sizeof(int)*noOfSlot);
		}
	}


	noOfTopKNewPool = (int **) malloc(sizeof(int *)*expectedK);
	for (i = 0; i < expectedK; i++)
	{
		noOfTopKNewPool[i] = (int *) malloc(sizeof(int)*noOfSlot);
		//memset(noOfTopKNewPool[i], 0, sizeof(int)*noOfSlot);
		for (j = 0; j < noOfSlot; j++)
		{
			noOfTopKNewPool[i][j] = 0;
		}

	}

// free (setF)
// free noOfSetFEntry

	largerTopK = (int *) malloc(sizeof(int)*expectedK);
	memset(largerTopK, 0, sizeof(int)*expectedK);

	b0 = R;
	for (i = 0; i < noOfTransRead; i++)
	{
		//if (i%100 == 0)
		//{
		//	printf("Trans. no. %d\n", i);
		//	fprintf(debugFilePtr, "Trans. no. %d\n", i);
		//}

		// for every b0 trans
		if ((i+1)%b0 == 0)
		{
			printf("~~~~Batch %d~~~~\n", i/b0);
			fprintf(debugFilePtr, "~~~~Batch %d~~~~\n", i/b0);
			
			//trans = readTrans(dataFilePtr);
			
			//if (i == 14) 
			//printf("fdlafjd\n");

			// switch bucket
			for (j = noOfBatch; j > 0; j--)
			{
				setQ[j] = setQ[j-1];

				for (k = 0; k < expectedK; k++)
				{
					memcpy(noOfSetQEntry[j][k], noOfSetQEntry[j-1][k], sizeof(int)*noOfSlot);
				}

				//noOfSetQEntry[j] = noOfSetQEntry[j=1];
			}
			

			startIndex = i-b0+1;
			endIndex = i;

			noOfBatchProcess = (i+1)/b0;

			if (i+1 == b0)
			{
				for (j = 0; j < expectedK; j++)
				{
					largerTopK[j] = topK+D;//topK*10;
				}
			}
			else
			{
				for (j = 0; j < expectedK; j++)
				{
					largerTopK[j] = topK+D;
				}
			}
	
			// find potential frequent itemset
			//pool = findPotentialFrequent(startIndex, endIndex, noOfTopKPool, n0, topK+D);
			pool = findPotentialFrequent(startIndex, endIndex, noOfTopKPool, n0, largerTopK);

			newPool = createNewPool(pool, noOfTopKPool, noOfTopKNewPool);
			//newPool = (entryPtr **) malloc(sizeof(entryPtr **)*100);

			printf("Building tree..\n");
			createFPTree(startIndex, endIndex-startIndex+1);
			for (l = 0; l < expectedK; l++)
			{
				itemsetSize = l+1;

				// mark zero
				markZero(setF[l], noOfSetFEntry[l]);

				// union with the global pool
				addToSetF(setF[l], noOfSetFEntry[l], pool[l], noOfTopKPool[l], itemsetSize);


//{
//int itemset[2];
//if (l == 1)
//{
//if (i/b0 == 7)
//{
//	printf("kfdla\n");
//}
//itemset[0] = 127;
//itemset[1] = 221;
//printf(" ----> Count of (%d, %d) from %d to %d = %d\n", itemset[0], itemset[1], 0, (i/b0)*R-1, findCountBatch(itemset, 2, dataFile, 0, (i/b0)*R-1));
//printf(" ----> Count of (%d, %d) from %d to %d = %d\n", itemset[0], itemset[1], (i/b0)*R, 8*R-1, findCountBatch(itemset, 2, dataFile, (i/b0)*R, ((i+1)/b0)*R-1));
//printItemsetCount(debugFilePtr, setF[l], noOfSetFEntry[l], itemset, 2);
//}
//}
				// findCount
				printf("  Counting with zero mark (Size %d)...\n", l);
				//findCountWithZeroMark(setF[l], noOfSetFEntry[l], dataFile, itemsetSize, startIndex, endIndex);
				findCountWithZeroMark(setF[l], noOfSetFEntry[l], dataFile, itemsetSize, startIndex, endIndex, newPool[l], noOfTopKNewPool[l]);
//{
//int itemset[2];
//if (l == 1)
//{
//itemset[0] = 127;
//itemset[1] = 221;
//printItemsetCount(debugFilePtr, setF[l], noOfSetFEntry[l], itemset, 2);
//}
//}				

				// free pool
				//freePool(pool[l]);
				for (j = 0; j < noOfTopKPool[l]; j++)
				{
					free(pool[l][j].item);
				}
				free(pool[l]);
				
				if (i == R-1)
				//if (i == R-1)
				{
					
					//if (l == 0)
					//{
					
					//supportThreshold = 0.5;
					// temp
					
					supportCount = find_KthFrequent(setF[l], noOfSetFEntry[l], topK+D);
					supportThreshold[l] = supportCount/((double) (i+1));
					//int find_KthFrequent(entryPtr *hash, int *noOfHashEntry, int K)
					
					
					
					n2 = calculateOptimalObser(maxTransSize, itemsetSize, sigma, supportThreshold[l]);
					
					n0[l] = maximum(n1, n2);
					
					
					printf("  Updating n0 to %d (n2:%d) for size %d\n", n0[l], n2, l);
					fprintf(debugFilePtr, "  Updating n0 to %d (n2:%d) for size %d and support count %d\n", n0[l], n2, l, supportCount);
					
					
					
					printf("                    supportThreshold:%.6f\n", supportThreshold[itemsetSize-1]);
					fprintf(debugFilePtr, "                    supportThreshold:%.6f\n", supportThreshold[itemsetSize-1]);
					
					runningError = calculateRunningError(supportThreshold[itemsetSize-1], sigma, i);
					printf("                    running error %.6f\n", runningError);
					fprintf(debugFilePtr, "                    running error %.6f\n", runningError);
					//}
					//else
					//{
					//	n0[l] = n0[0];
					//}
				}

			
				
				// if a batch leaving the sliding window
				if (noOfBatchProcess > noOfBatch)
				//if (0)
				{
					// ray
					//if (l == 1)
					//{
					//	fprintf(debugFilePtr, "  ###### Printing setF (Size %d) (BEFORE) #####\n", l+1);
					//	printHash(debugFilePtr, setF[l], noOfSetFEntry[l], l+1);
					//}

					//decrement the count in setF AND remove entries with count 0 in setF
					removeFromSetF(setF[l], noOfSetFEntry[l], setQ[noOfBatch][l], noOfSetQEntry[noOfBatch][l], itemsetSize);
					
					// free setQ n_b
					// free 
					

					// ray
					//k = 1;
					//j = noOfBatch;
					//for (j = 0; j < noOfBatch; j++)
					//for (k = 0; k < expectedK; k++)
					//if (l == 1)
					//{
					//	fprintf(debugFilePtr, "  ###### Printing set Q[%d] (Size %d) (deleting) ########\n", j, k+1);
					//	printHash(debugFilePtr, setQ[j][k], noOfSetQEntry[j][k], k+1);

					//	fprintf(debugFilePtr, "  ###### Printing setF (Size %d) (AFTER) #####\n", l+1);
					//	printHash(debugFilePtr, setF[l], noOfSetFEntry[l], l+1);
					//}
				
					
					for (k = 0; k < noOfSlot; k++)
					{
						if (noOfSetQEntry[noOfBatch][l][k] > 0)
						{
							for (j = 0; j < noOfSetQEntry[noOfBatch][l][k]; j++)
							{
								free(setQ[noOfBatch][l][k][j].item);
							}
							free(setQ[noOfBatch][l][k]);
						}
					}
					free(setQ[noOfBatch][l]);
							
					//free(noOfSetQEntry[noOfBatch][l]);
					
				
				}
				
				// remove infreq itemset
				//pool = findPotentialFrequent(startIndex, endIndex, noOfTopKPool);
				removePotentialInfrequent(setF[l], noOfSetFEntry[l], itemsetSize, i, n0, topK+D);
				
				// print setF
				//printf("Printing setF (Size %d)...\n", itemsetSize);
				//fprintf(debugFilePtr, "Printing setF (Size %d)...\n", itemsetSize);
				printHash(debugFilePtr, setF[l], noOfSetFEntry[l], itemsetSize);


				// create all possible count of itemset of size itemsetSize
				//output = possibleItemset(trans->item, trans->noOfItem, itemsetSize, &noOfOutput);
				
				// for each possible itemset
				//for (j = 0; j < noOfOutput; j++)
				//{
					
					
					// do the main step
				//	topNeg_doMainStep(i, hash[l], noOfHashEntry[l], output[j], itemsetSize, n0, n1);
					
					
					// free output
				//	free(output[j]);
				//}
				// free output
				//free(output);
				
				// printHash
				//printf("Printing Hash (Size %d)...\n", itemsetSize);
				//fprintf(debugFilePtr, "Printing Hash (Size %d)...\n", itemsetSize);
				//printHash(debugFilePtr, hash[l], noOfHashEntry[l], itemsetSize);
				
			}

			// assign the newPool to the Q
			setQ[0] = newPool;
			for (k = 0; k < expectedK; k++)
			{
				memcpy(noOfSetQEntry[0][k], noOfTopKNewPool[k], sizeof(int)*noOfSlot);

				//free(noOfTopKNewPool[k]);
			}

			// ray
			//k = 1;
			//for (j = 0; j < noOfBatch; j++)
			//for (k = 0; k < expectedK; k++)
			//{
			//	fprintf(debugFilePtr, "  ###### Printing set Q[%d] (Size %d) ########\n", j, k+1);
			//	printHash(debugFilePtr, setQ[j][k], noOfSetQEntry[j][k], k+1);
			//}

			//free(noOfTopKNewPool);

			freeTree();

			free(pool);

			//free(setQ[noOfBatch]);
						
			//free(noOfSetQEntry[noOfBatch]);
			
			// free trans
			//free(trans->item);
			//free(trans);
		}
	}

	free(noOfTopKPool);

	free(largerTopK);

	// free 
	for (i = 0; i < noOfBatch; i++)
	{
		for (j = 0; j < expectedK; j++)
		{
			for (k = 0; k < noOfSlot; k++)
			{
				if (noOfSetQEntry[i][j][k] > 0)
				{
					for (l = 0; l < noOfSetQEntry[i][j][k]; l++)
					{
						free(setQ[i][j][k][l].item);
					}
					free(setQ[i][j][k]);
				}
			}
			free(setQ[i][j]);

			//free(noOfSetQEntry[i][j]);
		}
		free(setQ[i]);

		//free(noOfSetQEntry[i]);
	}
	free(setQ);

	//free(noOfSetQEntry);



#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime2);	

 userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
 sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

 printf("User time : %f seconds\n",userTime);
 printf("System time : %f seconds\n\n",sysTime);

 	timeFilePtr = (FILE *) fopen("time.txt", "w");
	fprintf(timeFilePtr, "Data Stream\n");
	fprintf(timeFilePtr, "-----------\n");
	fprintf(timeFilePtr, "User time : %f seconds\n",userTime);
    fprintf(timeFilePtr, "System time : %f seconds\n\n",sysTime);
#endif

	// output
	//int **find_output(entryPtr *hash, int *noOfHashEntry, int K)
	//finalResult = (int ***) malloc(sizeof(int **)*expectedK);
	//finalCount = (int **) malloc(sizeof(int *)*expectedK);
	finalResult = (entryPtr *) malloc(sizeof(entryPtr)*expectedK);
	noOfFinal = (int *) malloc(sizeof(int)*expectedK);
	memset(noOfFinal, 0, sizeof(int)*expectedK);
	arrayBound = topK*100;
	for (i = 0; i < expectedK; i++)
	{
		//finalCount[i] = (int *) malloc(sizeof(int)*arrayBound);

		// int **find_output(entryPtr *hash, int *noOfHashEntry, int K, int *finalCount, int arrayBound)
		//finalResult[i] = find_output(hash[i], noOfHashEntry[i], topK, &(noOfFinal[i]), arrayBound, i+1);
		finalResult[i] = find_output(setF[i], noOfSetFEntry[i], topK, &(noOfFinal[i]), arrayBound, i+1);
	}

	// sort the stream result
	sortItemOrder(finalResult, noOfFinal);
	
	// print the output
	printf("Stream Result\n");
	printf("=============\n");
	fprintf(debugFilePtr, "Stream Result\n");
	fprintf(debugFilePtr, "=============\n");
	for (i = 0; i < expectedK; i++)
	{
		printf("Size %d\n", i);
		printf("~~~~~~~\n", i);
		fprintf(debugFilePtr, "Size %d\n", i);
		fprintf(debugFilePtr, "~~~~~~~\n", i);
		for (k = 0; k < noOfFinal[i]; k++)
		{
			for (j = 0; j < i+1; j++)
			{
				printf("%d ", finalResult[i][k].item[j]);
				fprintf(debugFilePtr, "%d ", finalResult[i][k].item[j]);
			}	
			printf("\t%d\n", finalResult[i][k].count);
			fprintf(debugFilePtr, "\t%d\n", finalResult[i][k].count);
		}
	}

	// BOMO
	//entryPtr *processBOMO(char *configFilename, int startIndex, int bucketSize, int topK, int L, int *noOfTopK)

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime1);
#endif 

	//startIndex = ;

	printf("processing BOMO...\n");
	fprintf(debugFilePtr, "processing BOMO...\n");
	noOfBOMOResult = (int *) malloc(sizeof(int)*expectedK);
	bomoResult = processBOMO(configFile, noOfTransRead - noOfBatch*R, noOfBatch*R, topK, expectedK, noOfBOMOResult);

	// sort the BOMO result
	sortItemOrder(bomoResult, noOfBOMOResult);

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime2);	

 userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
 sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

 printf("User time : %f seconds\n",userTime);
 printf("System time : %f seconds\n\n",sysTime);

 	
	fprintf(timeFilePtr, "BOMO\n");
	fprintf(timeFilePtr, "-----------\n");
	fprintf(timeFilePtr, "User time : %f seconds\n",userTime);
    fprintf(timeFilePtr, "System time : %f seconds\n\n",sysTime);
	fclose(timeFilePtr);
#endif

	printf("BOMO Result\n");
	printf("===========\n");
	fprintf(debugFilePtr, "BOMO Result\n");
	fprintf(debugFilePtr, "===========\n");
	for (i = 0; i < expectedK; i++)
	{
		printf("Size %d\n", i);
		printf("~~~~~~~\n");
		fprintf(debugFilePtr, "Size %d\n", i);
		fprintf(debugFilePtr, "~~~~~~~\n");
		for (k = 0; k < noOfBOMOResult[i]; k++)
		{
			for (j = 0; j < i+1; j++)
			{
				printf("%d ", bomoResult[i][k].item[j]);
				fprintf(debugFilePtr, "%d ", bomoResult[i][k].item[j]);
			}	
			printf("\t%d\n", bomoResult[i][k].count);
			fprintf(debugFilePtr, "\t%d\n", bomoResult[i][k].count);
		}
	}

	// compare (false +ve/-ve)
	noOfFalsePos = (int *) malloc(sizeof(int)*expectedK);
	noOfFalseNeg = (int *) malloc(sizeof(int)*expectedK);
	compareResult(finalResult, noOfFinal, bomoResult, noOfBOMOResult, noOfFalsePos, noOfFalseNeg);

	// print result
	printf("Final Result\n");
	printf("------------\n");
	fprintf(debugFilePtr, "Final Result\n");
	fprintf(debugFilePtr, "------------\n");

	// memory usage
	printf("K = %d\n", topK);
	printf("D = %d\n", D);
	fprintf(debugFilePtr, "K = %d\n", topK);
	fprintf(debugFilePtr, "D = %d\n", D);



	// print the false +ve/-ve
	for (i = 0; i < expectedK; i++)
	{
		for (j = 0; j < noOfSlot; j++)
		{
			stored[i] += noOfSetFEntry[i][j];
		}

		for (j = 0; j < noOfBatch; j++)
		{
			for (k = 0; k < noOfSlot; k++)
			{
				stored[i] += noOfSetQEntry[j][i][k];
			}
		}

		printf("Size %d\n", i);
		printf("  n0                     : %d\n", n0[i]);
		printf("  no. of entries stored  : %d\n", stored[i]);
		printf("  No. of Stream Output   : %d\n", noOfFinal[i]);
		printf("  No. of BOMO Output     : %d\n", noOfBOMOResult[i]);
		printf("  No. of false positives : %d\n", noOfFalsePos[i]);
		printf("  No. of false negatives : %d\n", noOfFalseNeg[i]);
		fprintf(debugFilePtr, "Size %d\n", i);
		fprintf(debugFilePtr, "  n0                     : %d\n", n0[i]);
		fprintf(debugFilePtr, "  no. of entries stored  : %d\n", stored[i]);
		fprintf(debugFilePtr, "  No. of Stream Output   : %d\n", noOfFinal[i]);
		fprintf(debugFilePtr, "  No. of BOMO Output     : %d\n", noOfBOMOResult[i]);
		fprintf(debugFilePtr, "  No. of false positives : %d\n", noOfFalsePos[i]);
		fprintf(debugFilePtr, "  No. of false negatives : %d\n", noOfFalseNeg[i]);
	}
	




//{
//int itemset[2];
//
//itemset[0] = 127;
//itemset[1] = 221;
//printf(" Count of (%d, %d) from %d to %d = %d\n", itemset[0], itemset[1], 0, 5*R-1, findCountBatch(itemset, 2, dataFile, 0, 5*R-1));
//printf(" Count of (%d, %d) from %d to %d = %d\n", itemset[0], itemset[1], 5*R, noOfTrans-1, findCountBatch(itemset, 2, dataFile, 5*R, noOfTrans-1));
//printf(" Count of (%d, %d) from %d to %d = %d\n", itemset[0], itemset[1], 5*R, 6*R-1, findCountBatch(itemset, 2, dataFile, 5*R, 6*R-1));
//printf(" Count of (%d, %d) from %d to %d = %d\n", itemset[0], itemset[1], 6*R, 7*R-1, findCountBatch(itemset, 2, dataFile, 6*R, 7*R-1));
//printf(" Count of (%d, %d) from %d to %d = %d\n", itemset[0], itemset[1], 7*R, 8*R-1, findCountBatch(itemset, 2, dataFile, 7*R, 8*R-1));
  //printf(" Count of (%d, %d) from %d to %d = %d\n", itemset[0], itemset[1], 8*R, 9*R-1, findCountBatch(itemset, 2, dataFile, 8*R, 9*R-1));
  //printf(" Count of (%d, %d) from %d to %d = %d\n", itemset[0], itemset[1], 9*R, 10*R-1, findCountBatch(itemset, 2, dataFile, 9*R, 10*R-1));
//printf(" Count of (%d, %d) from %d to %d = %d\n", itemset[0], itemset[1], 0, noOfTrans-1, findCountBatch(itemset, 2, dataFile, 0, noOfTrans-1));
//printf(" Count of (%d) from %d to %d = %d\n", itemset[0],  R, noOfTrans-1, findCountBatch(&(itemset[0]), 1, dataFile, R, noOfTrans-1));
//printf(" Count of (%d) from %d to %d = %d\n", itemset[1], R, noOfTrans-1, findCountBatch(&(itemset[1]), 1, dataFile, R, noOfTrans-1));
//}


	// free
	for (i = 0; i < expectedK; i++)
	{
		for (j = 0; j < noOfSlot; j++)
		{
			if (noOfSetFEntry[i][j] > 0)
			{
				for (k = 0; k < noOfSetFEntry[i][j]; k++)
				{
					free(setF[i][j][k].item);
				}
				free(setF[i][j]);
			}
		}
		free(setF[i]);
	}
	free(setF);

	free(noOfFalsePos);
	free(noOfFalseNeg);

	//for (i = 0; i <expectedK; i++)
	//{
	//	if (hash[i] != NULL)
	//	{
	//		free(hash[i]);
	//	}
	//}
	//free(hash);

	//for (i = 0; i < expectedK; i++)
	//{
	//	free(noOfHashEntry[i]);
	//}
	//free(noOfHashEntry);

	fclose(debugFilePtr);

	for (i = 0; i < noOfBatch; i++)
	{
		for (j = 0; j < expectedK; j++)
		{
			free(noOfSetQEntry[i][j]);
		}
		free(noOfSetQEntry[i]);
	}
	free(noOfSetQEntry);


	for (i = 0; i < expectedK; i++)
	{
		//for (j = 0; j < noOfFinal[i]; j++)
		//{
			//free(finalResult[i][j].item);
		//}
		free(finalResult[i]);
	}
	free(finalResult);

	free(noOfFinal);

	free(supportThreshold);

	free(stored);
}










void test()
{
	int *trans;

	int transSize;
	int itemsetSize;

	int noOfPossOutput;

	int **output;

	int i, j;

	transSize = 6;
	itemsetSize = 3;

	trans = (int *) malloc(sizeof(int)*transSize);

	trans[0] = 0;
	trans[1] = 1;
	trans[2] = 2;
	trans[3] = 3;
	trans[4] = 4;
	trans[5] = 5;

	printf("Trans: ");
	for (i = 0; i < transSize; i++)
	{
		printf("%d ", trans[i]);
	}
	printf("\nitemset size : %d\n", itemsetSize);

	output = possibleItemset(trans, transSize, itemsetSize, &noOfPossOutput);

	printf("No. of outputs: %d\n", noOfPossOutput);
	for (i = 0; i < noOfPossOutput; i++)
	{
		printf("%d. \t", i);
		for (j = 0; j < itemsetSize; j++)
		{
			printf("%d ", output[i][j]);
		}
		printf("\n");
	}

	free(trans);
	for (i = 0; i < noOfPossOutput; i++)
	{
		free(output[i]);
	}
	free(output);
}

void test2()
{
	int *index;
	int *value;

	int i;

	int no;

	no = 5;

	index = (int *) malloc(sizeof(int)*no);
	value = (int *) malloc(sizeof(int)*no);

	for (i = 0; i < no; i++)
	{
		index[i] = i;
	}

	value[0] = 3;
	value[1] = 5;
	value[2] = 1;
	value[3] = 7;
	value[4] = 2;

	printf("Original value is :\n");
	for (i = 0; i < no; i++)
	{
		printf("%d ", value[i]);
	}
	printf("\n");

	printf("Original index is :\n");
	for (i = 0; i < no; i++)
	{
		printf("%d ", index[i]);
	}
	printf("\n");

	printf("\nQuick sorting...\n");
	quicksort_i(index, value, 0, no-1);


	printf("Output value is :\n");
	for (i = 0; i < no; i++)
	{
		printf("%d ", value[i]);
	}
	printf("\n");

	printf("Output index is :\n");
	for (i = 0; i < no; i++)
	{
		printf("%d ", index[i]);
	}
	printf("\n");
}
