#include "trans.h"


int noOfSkip = 0;

transPtr readTrans(FILE *filePtr)
{
	transPtr returnValue;

	int i;

	returnValue = (transPtr) malloc(sizeof(trans));

	fscanf(filePtr, "%d", &(returnValue->noOfItem));

	returnValue->item = (int *) malloc(sizeof(int)*returnValue->noOfItem);

	for (i = 0; i < returnValue->noOfItem; i++)
	{
		fscanf(filePtr, " %d", &(returnValue->item[i]));
	}

	fscanf(filePtr, "\n");

	return returnValue;
}

transPtr *readData(char *filename, int noOfTrans)
{
	FILE *filePtr;
	transPtr *returnValue;
	int transNo;

	int i, j;

	transPtr tempValue;

	filePtr = (FILE *) fopen(filename, "r");
	if (filePtr == NULL)
	{
		printf("File %s cannot be opened!\n", filename);
		exit(0);
	}

	returnValue = (transPtr *) malloc(sizeof(transPtr)*noOfTrans);

	transNo = 0;

	// skip 
	tempValue = (transPtr) malloc(sizeof(trans));
	for (j = 0; j < noOfSkip; j++)
	{
		fscanf(filePtr, "%d", &(tempValue->noOfItem));

		tempValue->item = (int *) malloc(sizeof(int)*tempValue->noOfItem);

		for (i = 0; i < tempValue->noOfItem; i++)
		{
			fscanf(filePtr, " %d", &(tempValue->item[i]));
		}

		fscanf(filePtr, "\n");

		free(tempValue->item);
	}
	free(tempValue);
	

	//while (!feof(filePtr))
	for (j = 0; j < noOfTrans; j++)
	{
		returnValue[transNo] = (transPtr) malloc(sizeof(trans));

		fscanf(filePtr, "%d", &(returnValue[transNo]->noOfItem));

		returnValue[transNo]->item = (int *) malloc(sizeof(int)*returnValue[transNo]->noOfItem);

		for (i = 0; i < returnValue[transNo]->noOfItem; i++)
		{
			fscanf(filePtr, " %d", &(returnValue[transNo]->item[i]));
		}

		fscanf(filePtr, "\n");

		transNo++;
	}

	fclose(filePtr);

	return returnValue;
}


int noOfCombination(int n, int r)
{
//	return factorial(n)/(factorial(r)*factorial(n-r));

	double no1;

	//double no2;

	int i;

	int returnValue;

	
	no1 = 1;
	//for (i = r+1; i <= n; i++)
	for (i = n; i >= r+1; i--)
	{
		no1 *= i/( (double) (n-i+1) );
	}
	//no2 = factorial(n-r);
	
	returnValue = (int) (no1 + 0.1);//no1/no2;

/*
	no1 = 1;
	for (i = r+1; i <= n; i++)
	{
		no1 *= i;
	}
	no2 = 1;
	for (i = 0; i < n-r; i++)
	{
		no2 *= (i+1);
	}

	returnValue = (int) (no1/no2 + 0.1);
*/
	

	return returnValue;
}

int **possibleItemset(int *trans, int transSize, int itemsetSize, int *noOfPossOutput)
{
	int *pointer;
	int i;

	int **returnValue;

	int count = 0;

	int temp = 0;

	int isFinish = 0;

	int no;

	if (itemsetSize > transSize)
	{
		(*noOfPossOutput) = 0;
		return NULL;
	}


	pointer = (int *) malloc(sizeof(int)*itemsetSize);

	for (i = 0; i < itemsetSize; i++)
	{
		pointer[i] = i;
	}

	(*noOfPossOutput) = noOfCombination(transSize, itemsetSize);

	returnValue = (int **) malloc(sizeof(int *)*(*noOfPossOutput));
	for (i = 0; i < (*noOfPossOutput); i++)
	{
		returnValue[i] = (int *) malloc(sizeof(int)*itemsetSize);
	}

	while (count < (*noOfPossOutput))
	{
		for (i = 0; i < itemsetSize; i++)
		{
			returnValue[count][i] = trans[pointer[i]];
		}
		count++;

		no = 0;
		do 
		{
			no++;
			temp = itemsetSize-no;
			if (temp < 0)
			{
				isFinish = 1;
				break;
			}
			pointer[temp]++;
		}
		while (pointer[temp]+itemsetSize-1-temp >= transSize);

		if (isFinish == 1)
		{
			// check whether it is the last
			//if (count == (*noOfPossOutput))
			//{
			//	printf("Right Result!\n");
			//}
			//else
			//{
			//	printf("Wrong Result!\n");
			//}
	
			break;
		}

		for (i = temp+1; i < itemsetSize; i++)
		{
			pointer[i] = pointer[temp]+(i-temp);
		}
				
	}

	free(pointer);

	return returnValue;
}



void sortItemOrderEach(entryPtr bomoResult, int noOfBOMOResult)
{
	int i, j;

	int *list;
	int *index;

	int size;

	if (noOfBOMOResult <= 0)
	{
		return;
	}

	size = bomoResult[0].itemsetSize;

	list = (int *) malloc(sizeof(int)*size);
	index = (int *) malloc(sizeof(int)*size);
	for (i = 0; i < size; i++)
	{
		index[i] = i;
	}

	for (i = 0; i < noOfBOMOResult; i++)
	{
		for (j = 0; j < size; j++)
		{
			list[j] = bomoResult[i].item[j];
		}

		quicksort_i(index, list, 0, size-1);
		
		for (j = 0; j < size; j++)
		{
			bomoResult[i].item[j] = list[size-j-1];
		}
	}

	free(list);
	free(index);
}


void sortItemOrder(entryPtr *bomoResult, int *noOfBOMOResult)
{
	int i;

	for (i = 0; i < expectedK; i++)
	{
		sortItemOrderEach(bomoResult[i], noOfBOMOResult[i]);
	}
}


void addEntry(entryPtr *bucket, int noOfPreEntry, int *itemset, int itemsetSize, int freq)
{
	entryPtr tempBucket;

	int i;

	entryPtr bucketProcess;
	int noOfEntryProcess;

	noOfEntryProcess = noOfPreEntry;

	bucketProcess = (*bucket);

	tempBucket = (entryPtr) malloc(sizeof(entry)*(noOfEntryProcess+1));

	for (i = 0; i < noOfEntryProcess; i++)
	{
		tempBucket[i].itemsetSize = bucketProcess[i].itemsetSize;
		tempBucket[i].item = bucketProcess[i].item;
		tempBucket[i].count = bucketProcess[i].count;

		tempBucket[i].isMark = bucketProcess[i].isMark;
	}

	tempBucket[noOfEntryProcess].itemsetSize = itemsetSize;
	//tempBucket[noOfEntryProcess].item = itemset;
	tempBucket[noOfEntryProcess].item = (int *) malloc(sizeof(int)*itemsetSize);
	memcpy(tempBucket[noOfEntryProcess].item, itemset, sizeof(int)*itemsetSize);
	tempBucket[noOfEntryProcess].count = freq;

	tempBucket[noOfEntryProcess].isMark = 1;

	if (noOfPreEntry > 0)
	{
		free(bucketProcess);
	}

	(*bucket) = tempBucket;
}

// remove the entry with freq
void removeEntry(entryPtr *bucket, int *noOfEntry, int freq)
{
int noOfEntryProcess;
entryPtr bucketProcess, tempBucket;
int noOfDel;
int i;
int counter;

	noOfEntryProcess = (*noOfEntry);
	bucketProcess = (*bucket);

	noOfDel = 0;
	for (i = 0; i < noOfEntryProcess; i++)
	{
		if (bucketProcess[i].count == freq)
		{
			noOfDel++;
		}
	}

	if (noOfEntryProcess-noOfDel > 0)
	{
		tempBucket = (entryPtr) malloc(sizeof(entry)*(noOfEntryProcess-noOfDel));

		counter = 0;
		for (i = 0; i < noOfEntryProcess; i++)
		{
			if (bucketProcess[i].count != freq)
			{
				tempBucket[counter].itemsetSize = bucketProcess[i].itemsetSize;
				tempBucket[counter].item = bucketProcess[i].item;
				tempBucket[counter].count = bucketProcess[i].count;

				tempBucket[counter].isMark = bucketProcess[i].isMark;

				counter++;
			}
		}

		if (noOfEntryProcess > 0)
		{
			free(bucketProcess);
		}

		(*bucket) = tempBucket;
		(*noOfEntry) = noOfEntryProcess - noOfDel;
	}
	else
	{
		if (noOfEntryProcess > 0)
		{
			free(bucketProcess);
		}

		(*bucket) = NULL;
		(*noOfEntry) = 0;
	}

}

// 1 : same
// 0 : difference
int compareItemsetSize(int itemSize, int *itemset1, int *itemset2)
{
	int i;

	int returnValue;

	returnValue = 1;
	for (i = 0; i < itemSize; i++)
	{
		if (itemset1[i] != itemset2[i])
		{
			returnValue = 0;
			break;
		}
	}
	return returnValue;
}

// 1 : exist in the set
// 0 : not exist in the set
int compareItemset(entryPtr testResult, int testIndex, entryPtr setElt, int noOfSetElt)
{
	int i;

	int returnValue; 

	int isSame;

	returnValue = 0;

	for (i = 0; i < noOfSetElt; i++)
	{
		if (testResult[testIndex].itemsetSize == setElt[i].itemsetSize)
		{

			isSame = compareItemsetSize(testResult[testIndex].itemsetSize, testResult[testIndex].item, setElt[i].item);

			if (isSame == 1)
			{
				returnValue = 1;
				break;
			}

		}
	}

	return returnValue;
}

int compareFalsePos(entryPtr finalResult, int noOfFinal, entryPtr bomoResult, int noOfBOMOResult)
{
	int returnValue = 0;

	int i;


	for (i = 0; i < noOfFinal; i++)
	{
		if (compareItemset(finalResult, i, bomoResult, noOfBOMOResult) == 0)
		{
			returnValue++;
		}
	}

	return returnValue;
}

int compareFalseNeg(entryPtr finalResult, int noOfFinal, entryPtr bomoResult, int noOfBOMOResult)
{
	int returnValue = 0;

	int i;

	for (i = 0; i < noOfBOMOResult; i++)
	{
		if (compareItemset(bomoResult, i, finalResult, noOfFinal) == 0)
		{
			returnValue++;
		}
	}

	return returnValue;
}


void compareResult(entryPtr *finalResult, int *noOfFinal, entryPtr *bomoResult, int *noOfBOMOResult, int *noOfFalsePos, int *noOfFalseNeg)
{
	int i;

	for (i = 0; i < expectedK; i++)
	{
		noOfFalsePos[i] = compareFalsePos(finalResult[i], noOfFinal[i], bomoResult[i], noOfBOMOResult[i]);
		noOfFalseNeg[i] = compareFalseNeg(finalResult[i], noOfFinal[i], bomoResult[i], noOfBOMOResult[i]);
	}
}


void testTrans()
{
	int *trans;

	int transSize;
	int itemsetSize;

	int noOfPossOutput;

	int **output;

	int i, j;

	transSize = 6;
	itemsetSize = 3;

	trans = (int *) malloc(sizeof(int)*transSize);

	trans[0] = 0;
	trans[1] = 1;
	trans[2] = 2;
	trans[3] = 3;
	trans[4] = 4;
	trans[5] = 5;

	printf("Trans: ");
	for (i = 0; i < transSize; i++)
	{
		printf("%d ", trans[i]);
	}
	printf("\nitemset size : %d\n", itemsetSize);

	output = possibleItemset(trans, transSize, itemsetSize, &noOfPossOutput);

	printf("No. of outputs: %d\n", noOfPossOutput);
	for (i = 0; i < noOfPossOutput; i++)
	{
		printf("%d. \t", i);
		for (j = 0; j < itemsetSize; j++)
		{
			printf("%d ", output[i][j]);
		}
		printf("\n");
	}

	free(trans);
	for (i = 0; i < noOfPossOutput; i++)
	{
		free(output[i]);
	}
	free(output);
}
